package jonasl.ime;

import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.content.res.Configuration;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.ListPreference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;
import android.preference.PreferenceManager;
import android.preference.PreferenceScreen;

public class PrefsLang extends PreferenceActivity implements OnSharedPreferenceChangeListener {
	
	public static ListPreference htcLangPref = null;
	
	public static String[][] mSettingsLocaleData;
	public static int mSettingsLocaleNumber;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		PreferenceScreen s = getPreferenceManager().createPreferenceScreen(this);
		setPreferenceScreen(s);

		PreferenceCategory c = new PreferenceCategory(this);
		c.setTitle("Language selection");
		c.setSummary("Only checked entries will be available");		
		s.addPreference(c);		

		CheckBoxPreference p = new CheckBoxPreference(this);
		p.setTitle("Czech");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Czech");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Danish");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Danish");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Dutch");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Dutch");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("English");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("English");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("French");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("French");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("German");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("German");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Greek");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Greek");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Italian");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Italian");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Norwegian");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Norwegian");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Polish");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Polish");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Portuguese");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Portuguese");
		c.addPreference(p);

		/*
		p = new CheckBoxPreference(this);
		p.setTitle("Romanian");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Romanian");
		c.addPreference(p);*/

		p = new CheckBoxPreference(this);
		p.setTitle("Russian");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Russian");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Spanish");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Spanish");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Swedish");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Swedish");
		c.addPreference(p);

		p = new CheckBoxPreference(this);
		p.setTitle("Turkish");
		p.setDefaultValue(true);
		p.setPersistent(true);
		p.setKey("Turkish");
		c.addPreference(p);
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
	}

	@Override
	protected void onResume() {
		super.onResume();
		getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
	}

	@Override
	protected void onPause() {
		super.onPause();
		getPreferenceScreen().getSharedPreferences().unregisterOnSharedPreferenceChangeListener(this);
	}
	
	@Override
	public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {
		
		if(htcLangPref == null)
			return;
		
		List<String> langs = getLangs(this);
		List<String> vals = getVals(this);		
		
		htcLangPref.setEntries(langs.toArray(new String[langs.size()]));
		htcLangPref.setEntryValues(vals.toArray(new String[langs.size()]));		
	}
	
	private static List<String> getLangs(Context context) {
		
		List<String> langs = new ArrayList<String>();
		SharedPreferences p = PreferenceManager.getDefaultSharedPreferences(context);

		if (p.getBoolean("English", true)) {
			langs.add("English");
		}
		if (p.getBoolean("Czech", true)) {
			langs.add("Czech");
		}
		if (p.getBoolean("Danish", true)) {
			langs.add("Danish");
		}
		if (p.getBoolean("Dutch", true)) {
			langs.add("Dutch");
		}
		if (p.getBoolean("French", true)) {
			langs.add("French");
		}
		if (p.getBoolean("German", true)) {
			langs.add("German");
		}
		if (p.getBoolean("Greek", true)) {
			langs.add("Greek");
		}
		if (p.getBoolean("Italian", true)) {
			langs.add("Italian");
		}
		if (p.getBoolean("Norwegian", true)) {
			langs.add("Norwegian");
		}
		if (p.getBoolean("Polish", true)) {
			langs.add("Polish");
		}
		if (p.getBoolean("Portuguese", true)) {
			langs.add("Portuguese");
		}
		
		/*if (p.getBoolean("Romanian", true)) {
			langs.add("Romanian");
		}*/
		if (p.getBoolean("Russian", true)) {
			langs.add("Russian");
		}
		if (p.getBoolean("Spanish", true)) {
			langs.add("Spanish");
		}
		if (p.getBoolean("Swedish", true)) {
			langs.add("Swedish");
		}
		if (p.getBoolean("Turkish", true)) {
			langs.add("Turkish");
		}
		
		return langs;
	}
	
	private static List<String> getVals(Context context) {
		List<String> vals = new ArrayList<String>();

		SharedPreferences p = PreferenceManager.getDefaultSharedPreferences(context);

		if (p.getBoolean("English", true)) {
			vals.add("0");
		}
		if (p.getBoolean("Czech", true)) {
			vals.add("7");
		}
		if (p.getBoolean("Danish", true)) {
			vals.add("8");
		}
		if (p.getBoolean("Dutch", true)) {
			vals.add("11");
		}
		if (p.getBoolean("French", true)) {
			vals.add("1");
		}
		if (p.getBoolean("German", true)) {
			vals.add("2");
		}
		if (p.getBoolean("Greek", true)) {
			vals.add("17");
		}
		if (p.getBoolean("Italian", true)) {
			vals.add("3");
		}
		if (p.getBoolean("Norwegian", true)) {
			vals.add("10");
		}
		if (p.getBoolean("Polish", true)) {
			vals.add("13");
		}
		if (p.getBoolean("Portuguese", true)) {
			vals.add("5");
		}
		/*
		if (p.getBoolean("Romanian", true)) {
			vals.add("16");
		}*/
		if (p.getBoolean("Russian", true)) {
			vals.add("6");
		}
		if (p.getBoolean("Spanish", true)) {
			vals.add("4");
		}
		if (p.getBoolean("Swedish", true)) {
			vals.add("9");
		}
		if (p.getBoolean("Turkish", true)) {
			vals.add("15");
		}
		
		return vals;
	}
	
	public static String getLanguageName(Context context, String id) {
		
		if(id.equals("0"))
			return "English";
		
		List<String> langs = getLangs(context);
		List<String> vals = getVals(context);
		
		for(int i = 0; i < vals.size(); i++) {
			if(vals.get(i).equals(id))
				return langs.get(i);
		}
		
		return "Unknown";
	}
	
	public static String getNextLanguage(Context context) {
		
		if(context == null)
			return "0";
		
		List<String> vals = getVals(context);

		if(vals.size() == 0)
			return "0";
		
		SharedPreferences p = PreferenceManager.getDefaultSharedPreferences(context);
		String current = p.getString("keyboard_language", "0");
		
		for(int i = 0; i < vals.size() - 1; i++) {
			if(vals.get(i).equals(current)){
				return vals.get(i + 1);
			}
		}
		
		return vals.get(0);
	}
	
	public static String getPreviousLanguage(Context context) {
		
		if(context == null)
			return "0";
		
		List<String> vals = getVals(context);

		if(vals.size() == 0)
			return "0";
		
		SharedPreferences p = PreferenceManager.getDefaultSharedPreferences(context);
		String current = p.getString("keyboard_language", "0");
		
		for(int i = vals.size() - 1; i > 0; i--) {
			if(vals.get(i).equals(current)){
				return vals.get(i - 1);
			}
		}
		
		return vals.get(vals.size() - 1);
	}

	public static int localeLanguagePicker (Context context) {
    	int dims[] = new int[]{19, 2};
        String[][] d = (String[][]) java.lang.reflect.Array.newInstance(String.class, dims);
        
        SharedPreferences p = PreferenceManager.getDefaultSharedPreferences(context);
        int i = 0;
		if (p.getBoolean("English", true)) {			
			d[i][0] = "English";
        	d[i][1] = "0";
        	i++;
		}
		if (p.getBoolean("Czech", true)) {
			d[i][0] = "Czech";
        	d[i][1] = "7";
        	i++;
		}
		if (p.getBoolean("Danish", true)) {
			d[i][0] = "Danish";
        	d[i][1] = "8";
        	i++;
		}
		if (p.getBoolean("Dutch", true)) {
			d[i][0] = "Dutch";
        	d[i][1] = "11";
        	i++;
		}
		if (p.getBoolean("French", true)) {		
			d[i][0] = "French";
        	d[i][1] = "1";
        	i++;
		}
		if (p.getBoolean("German", true)) {			
			d[i][0] = "German";
        	d[i][1] = "2";
        	i++;
		}
		if (p.getBoolean("Greek", true)) {			
			d[i][0] = "Greek";
        	d[i][1] = "17";
        	i++;
		}
		if (p.getBoolean("Italian", true)) {
			d[i][0] = "Italian";
        	d[i][1] = "3";
        	i++;
		}
		if (p.getBoolean("Norwegian", true)) {
			d[i][0] = "Norwegian";
        	d[i][1] = "10";
        	i++;
		}
		if (p.getBoolean("Polish", true)) {
			d[i][0] = "Polish";
        	d[i][1] = "13";
        	i++;;
		}
		if (p.getBoolean("Portuguese", true)) {
			d[i][0] = "Portuguese";
        	d[i][1] = "5";
        	i++;
		}
		/*
		if (p.getBoolean("Romanian", true)) {
			d[i][0] = "Romanian";
        	d[i][1] = "16";
        	i++;
		}*/
		if (p.getBoolean("Russian", true)) {
			d[i][0] = "Russian";
        	d[i][1] = "6";
        	i++;
		}
		if (p.getBoolean("Spanish", true)) {
			d[i][0] = "Spanish";
        	d[i][1] = "4";
        	i++;
		}
		if (p.getBoolean("Swedish", true)) {
			d[i][0] = "Swedish";
        	d[i][1] = "9";
        	i++;
		}
		if (p.getBoolean("Turkish", true)) {			
			d[i][0] = "Turkish";
        	d[i][1] = "15";
        	i++;
		}
		
		if(i == 0) {
			d[i][0] = "English";
        	d[i][1] = "0";
        	i++;
		}
		
		mSettingsLocaleData = d;
	    mSettingsLocaleNumber = i;
	    
	    String key = "keyboard_language";
    	
    	if(!p.contains(key)) {
    		p.edit().putString(key, d[0][1]).commit();
    		Static.log("Current language not set, defaulting to " + d[0][1] + " " + d[0][0]); 
    	}
    	
    	String ret = p.getString("keyboard_language", "0");
    	
    	return Integer.valueOf(ret);
	}	
}
