package jonasl.ime;

import android.content.res.Configuration;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;
import android.preference.PreferenceScreen;

public class PrefsPreDict extends PreferenceActivity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		PreferenceScreen s = getPreferenceManager().createPreferenceScreen(this);		
		setPreferenceScreen(s);
		
		PreferenceCategory c = new PreferenceCategory(this);
		c.setTitle("Prediction & dictionary");
		s.addPreference(c);
		
		CheckBoxPreference predictInWordsPref = new CheckBoxPreference(this);
		predictInWordsPref.setTitle("Predict in words");
		predictInWordsPref.setSummary("Start prediction even if cursor is inside a word (QWERTY)");
		predictInWordsPref.setDefaultValue(false);
		predictInWordsPref.setPersistent(true);
		predictInWordsPref.setKey("predictInWords");

		c.addPreference(predictInWordsPref);

		CheckBoxPreference predictAfterWordsPref = new CheckBoxPreference(this);
		predictAfterWordsPref.setTitle("Predict after words");
		predictAfterWordsPref.setSummary("Start prediction with cursor right after a word (QWERTY)");
		predictAfterWordsPref.setDefaultValue(true);
		predictAfterWordsPref.setPersistent(true);
		predictAfterWordsPref.setKey("predictAfterWords");

		c.addPreference(predictAfterWordsPref);

		CheckBoxPreference alwaysPredictInBrowserPref = new CheckBoxPreference(this);
		alwaysPredictInBrowserPref.setTitle("Predict in Browser");
		alwaysPredictInBrowserPref.setSummary("If disabled prediction is active for multi line fields only (QWERTY)");
		alwaysPredictInBrowserPref.setDefaultValue(true);
		alwaysPredictInBrowserPref.setPersistent(true);
		alwaysPredictInBrowserPref.setKey("alwaysPredictInBrowser");

		c.addPreference(alwaysPredictInBrowserPref);

		CheckBoxPreference predictInURLPref = new CheckBoxPreference(this);
		predictInURLPref.setTitle("Predict in URLs");
		predictInURLPref.setSummary("Enable prediction URL fields");
		predictInURLPref.setDefaultValue(false);
		predictInURLPref.setPersistent(true);
		predictInURLPref.setKey("predictInURL");

		c.addPreference(predictInURLPref);

		CheckBoxPreference ignoreAutoCompletePref = new CheckBoxPreference(this);
		ignoreAutoCompletePref.setTitle("Ignore autocomplete flag");
		ignoreAutoCompletePref.setSummary("Enable prediction in search bar for example");
		ignoreAutoCompletePref.setDefaultValue(false);
		ignoreAutoCompletePref.setPersistent(true);
		ignoreAutoCompletePref.setKey("ignoreAutoComplete");

		c.addPreference(ignoreAutoCompletePref);

		CheckBoxPreference ignoreFilterPref = new CheckBoxPreference(this);
		ignoreFilterPref.setTitle("Ignore filter flag");
		ignoreFilterPref.setSummary("Enable prediction in fields performing their own filtering");
		ignoreFilterPref.setDefaultValue(false);
		ignoreFilterPref.setPersistent(true);
		ignoreFilterPref.setKey("ignoreFilter");

		c.addPreference(ignoreFilterPref);
		
		
		CheckBoxPreference spaceAcceptPref = new CheckBoxPreference(this);
		spaceAcceptPref.setTitle("Accept with space");
		spaceAcceptPref.setSummary("Accept dictionary suggestion with space");
		spaceAcceptPref.setDefaultValue(true);
		spaceAcceptPref.setPersistent(true);
		spaceAcceptPref.setKey("spaceAccept");

		c.addPreference(spaceAcceptPref);

		
		CheckBoxPreference separatorAcceptPref = new CheckBoxPreference(this);
		separatorAcceptPref.setTitle("Accept by separator");
		separatorAcceptPref.setSummary("Accept dictionary suggestion with separator (., etc)");
		separatorAcceptPref.setDefaultValue(true);
		separatorAcceptPref.setPersistent(true);
		separatorAcceptPref.setKey("separatorAccept");

		c.addPreference(separatorAcceptPref);
		
		CheckBoxPreference symbolAcceptPref = new CheckBoxPreference(this);
		symbolAcceptPref.setTitle("Accept by symbol key");
		symbolAcceptPref.setSummary("Accept dictionary suggestion with symbol key (12#)");
		symbolAcceptPref.setDefaultValue(true);
		symbolAcceptPref.setPersistent(true);
		symbolAcceptPref.setKey("symbolAccept");

		c.addPreference(symbolAcceptPref);	
		

		CheckBoxPreference noAutoAddPref = new CheckBoxPreference(this);
		noAutoAddPref.setTitle("No auto add words");
		noAutoAddPref.setSummary("Disable automatic adding of words to user dictionary");
		noAutoAddPref.setDefaultValue(false);
		noAutoAddPref.setPersistent(true);
		noAutoAddPref.setKey("noAutoAdd");

		c.addPreference(noAutoAddPref);
		
		
		CheckBoxPreference insertAddedWordPref = new CheckBoxPreference(this);
		insertAddedWordPref.setTitle("Insert added word");
		insertAddedWordPref.setSummary("Insert manually added words into edited text");
		insertAddedWordPref.setDefaultValue(true);
		insertAddedWordPref.setPersistent(true);
		insertAddedWordPref.setKey("insertAddedWord");

		c.addPreference(insertAddedWordPref);
	}
	
	@Override
    public void onConfigurationChanged(Configuration newConfig) {    	
      super.onConfigurationChanged(newConfig);
    }
}
