package jonasl.ime;

import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.content.res.Configuration;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.ListPreference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;
import android.preference.PreferenceScreen;

public class PrefsVoice extends PreferenceActivity implements OnSharedPreferenceChangeListener {

	public static String[] entries = {"Never", "For English", "For most non English",};
	public static String[] values = {"never", "english", "most"};
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		SharedPreferences prefs = getPreferenceManager().getSharedPreferences();
		PreferenceScreen s = getPreferenceManager().createPreferenceScreen(this);		
		setPreferenceScreen(s);
		
		PreferenceCategory c = new PreferenceCategory(this);
		c.setTitle("Voice input");
		s.addPreference(c);
		
		ListPreference voicePref = new ListPreference(this);
		voicePref.setKey("voiceButton");
		voicePref.setTitle("Show voice button");
		voicePref.setSummary(getEntry(prefs.getString("voiceButton", "english")));
		voicePref.setEntries(entries);
		voicePref.setDefaultValue("english");
		voicePref.setEntryValues(values);

		c.addPreference(voicePref);
		
		CheckBoxPreference altServerPref = new CheckBoxPreference(this);
		altServerPref.setTitle("Alternative voice server");
		altServerPref.setSummary("Google dev server w. German support. Warning: not online 24/7");
		altServerPref.setDefaultValue(false);
		altServerPref.setPersistent(true);
		altServerPref.setKey("useAltServer");

		c.addPreference(altServerPref);
	}
	
	@Override
    public void onConfigurationChanged(Configuration newConfig) {    	
      super.onConfigurationChanged(newConfig);
    }
	
	@Override
	protected void onResume() {
		super.onResume();
		getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
	}

	@Override
	protected void onPause() {
		super.onPause();
		getPreferenceScreen().getSharedPreferences().unregisterOnSharedPreferenceChangeListener(this);
	}	
	
	@Override
	public void onSharedPreferenceChanged(SharedPreferences prefs, String key) {
		if(!key.equals("voiceButton"))
			return;
		
		getPreferenceScreen().findPreference(key).setSummary(getEntry(prefs.getString(key, "error")));
	}
	
	private String getEntry(String value) {
		for(int i = 0; i < values.length; i++) {
			if(values[i].equals(value))
				return entries[i];
		}
		
		return "Internal error";
	}
}
