/*
 * This means that you can do whatever you want with it as long as you are nice
 * enough to credit all the people and companies that have contributed and buy
 * them at least on beer each. This includes myself (obviously) but also HTC.
 * It's their keyboard after all.
 * 
 */

package jonasl.ime;

import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.inputmethodservice.InputMethodService;

import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.os.Vibrator;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;
import android.preference.PreferenceManager;
import android.preference.PreferenceScreen;
import android.text.InputType;
import android.text.SpannableStringBuilder;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.util.Log;
import android.util.TypedValue;
import android.view.GestureDetector;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.view.ViewGroup.LayoutParams;
import android.view.inputmethod.CompletionInfo;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputConnection;
import android.view.inputmethod.InputMethodManager;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.TextView;

/*
 * 13
 * Option: Left alignment of word candidate list * 
 * Experimental Droid 2.1 support
 * Fixed More robust period insertion on space double tap
 * Fixed rare FC when moving the candidate list (HTC bug) 
 * Fixed typing " I'm " with compact qwerty (HTC bug)
 * Fixed FC when clicking on disabled T9 toggle button (HTC bug)
 * Fixed better compatibility between space insertion and smileys
 */

/*
 * 14
 * Option: Disable automatic adding to user dictionary
 * Option: Custom popup delay for secondary characters
 * Option: Swipe right for voice input
 * Option: Toggle space insertion after separators
 * Option: Access hidden HTC internal settings (control vibrator etc. TAKE CARE IN HERE!)
 * Option: Prediction in URL fields
 * Option: Disable key preview popup
 * Fixed: Cleaned up settings dialog a bit
 * Fixed: Deleting voice text by back space now works again
 * Fixed: Space insertion is now always disabled in some fields (browser URL etc). Caused problems
 * New: My own (experimental!) hard keyboard mapping code (enables space in URL for hard KB, removes need for QWERTZ hack etc.)
 * New: apk version now shows my version instead of HTC's version (smoother upgrades, more logical)
 * New: Import/export user dictionary
 * New: Can now enter any character into user dictionary (HTC just allowed letters and digits) 
 */

/*
 * 15 
 * Fixed URL KB space hack caused FC on slash key in compact qwerty and phone keypad 
 */

/*
 * 16 
 * Fixed: space insertion is now disabled for password fields with compact qwerty & phone keypad
 * Prediction cache not emptied in some cases, resulting in weird behavior when starting input next time
 */

/*
 * 17
 * Option: Toggle prediction in one line browser forms
 */

/*
 * 18
 * Changed: Hid HTC hidden settings again (caused too much trouble).
 * Option: Custom vibration length
 * Option: Smiley button instead of hide kb button.
 * Option: Toggle smiley dashes
 * Fixed: User dictionary editor no longer FC's on modaco custom rom
 * Fixed: Word candidate bar now works on Droid 2.1
 */


/*
 * 19
 * Lowres up to speed
 * Changed: Import/export is now threaded
 * New: Pipe key in qwerty symbol keyboard
 * Option: Clear user dictionary
 * Option: Swipe down to hide KB
 * Option: Swipe left to delete last word
 * Option: Character replacement w. definitions in .htcime (can remove diacritic chars)
 * Option: Custom smileys
 * Fixed: Voice hack enabled by default even if disabled in settings
 */

/*
 * 20
 * 
 * Fixed: Swiping more robust, some quick presses was falsely detected as swipes (still not perfect but better).
 * Fixed: Long press on symbol key now working again.
 * Fixed: Tweaked candidate bar height calculation
 * Fixed: Improved HTC popup timer when lag is detected
 * Fixed: Android smiley is :-\ and not :-/
 * Fixed: Bug in landscape autocompletion (gmail compose etc.)
 * Fixed: Autocap issues in certain cases (blame HTC :-P)
 * Fixed: Better handling of (pseudo) multi touch events (easier to press space and periods etc. more quickly)
 * Fixed: Workaround for back button bug in xScope browser
 * Option: Swipe up for shift
 * Option: Swipe while composing a word (dict. showing)
 * Option: Swap Smiley/12# button. Experimental. Not great with custom smileys.
 * Option: Insert word entered in add word dialog into edited text.
 */

/*
 * 21
 * 
 * Fixed: More swipe detection tuning
 * Fixed: Less laggy sound and vibration feedback with swiping enabled
 * Fixed: Space insert more robust
 * Option: Move cursor with volume keys (For SE Xperia X10 perhaps?)
 * Option: Move Scandinavian popup chars closer to pressed key
 *  
 */

/*
 * 22
 * 
 * New: My own package name (installs on unrooted Sense ROMs like Desire)
 * New: Fast language & keyboard switching by gestures
 * New: Settings dialog redesigned 
 * New: No more .htcime on SD, all is now GUI based
 * New: Hires Clicker. Install for better calibration 
 * New: Version tracking by aTrackDog
 * Fixed: Scale landscape KB on Droid/Milestone/X10
 * Fixed: Add word dialog now shows kb automatically
 * Fixed: FC on show add word dialog in landscape
 * Fixed: Proper hires settings icon from Incredible
 * Fixed: P and W in phone number keyboard
 * Option: Configurable gesture actions
 * Option: Show current language on start
 * Option: Kill keyboard from settings  
 * Option: Disable voice button also for English
 * Option: Use phone keypad / compact qwerty symbol kb for QWERTY
 * Option: Toggle accept dict. suggestion by space
 * Option: Toggle accept dict. suggestion by separators
 * Option: Volume keys for dpad up/down
 * Gesture: Delete last sentence
 * Gesture: Move to end of word
 * Gesture: Cycle language
 * Gesture: Cycle keyboard types 
 * 
 */

/*
 * 23
 * 
 * Fixed: User dictionary broke on v22 due to changed package name
 * 
 */

/*
 * 24
 * 
 * Fixed: Droid/Milestone/X10 landscape kb broken due to upscaling
 * Fixed: Alt. symbol kb. not set correctly on start input
 * Fixed: FC on boot when using some locales
 * Fixed: Delete last sentence tweaked
 * 
 */

/*
 * 25
 * New: Move lang. specific popup chars closer to pressed key (help me support more langs!)
 * Option: Replace chars only for SMS
 * Option: Custom domains for .com key
 * Option: Insert period on double space
 * Option: Toggle accept dict. suggestion by 12# key
 * Option: Configurable custom sounds
 * Option: Change language with volume keys
 * Option: Adjust portrait QWERTY key width
 * Changed: Delete last sentence breaks on comma again.
 * Fixed: Space insertion disabled for URI fields (causing problems)
 * Fixed: Space insertion tweaked for French
 * Fixed: Removed Romanian since not working (blame HTC)
 * Fixed: Don't insert space if prediction is disabled in browser
 * Fixed: Predict in URL working again.
 * Fixed: Sound for HW KB working again
 * Gesture: Toggle QWERTY prediction on/off
 */

/*
 * 26
 * Fixed: Slightly better SMS detection
 * Fixed: Custom popup domains will work without enabling custom popup time (caused by typo)
 * New: € £ added to f popup 
 */

/* TODO
 * Gesture cursor before word 
 * Vibrator on Acer Liquid
 * No space insert after apostrophe or (
 * Disable settings key
 * Button width in landscape
 * Button height
 * £ € on f popup
 * 
 */

public class Static {

	public static final String tag = "HTC_IME_jonasl";
	public static final String versionString = "v25";

	/* Used for faking that I have a hardware keyboard in testing */
	public static boolean fakeHW = false;
	public static ArrayList<KeyEvent> fakeHWKeys = new ArrayList<KeyEvent>();
	public static int fakeHWIndex = 0;

	/* Variables */

	public static boolean shiftEnter;
	public static boolean forceAction;
	public static boolean showBar;
	public static boolean ignoreSilentMode;
	public static boolean predictInWords;
	public static boolean predictAfterWords;
	public static boolean predictInURL;
	public static boolean insertSpace;
	public static boolean insertPeriod;
	public static boolean insertSpaceAfterSeparator;
	public static boolean insertSpaceAfterWord;
	public static boolean insertSpaceAfterSmiley;
	public static boolean leftAlign;
	public static boolean noAutoAdd;
	public static boolean insertAddedWord;
	public static boolean customDelayToggle;
	public static boolean customDomainsToggle;
	public static boolean disablePreview;
	public static long customDelay;
	public static int swipeRight;
	public static int swipeDown;
	public static int swipeLeft;
	public static int swipeUp;
	public static boolean swipeWhenComposing;
	public static int tripleComma;
	
	public static boolean separatorAccept;
	public static boolean spaceAccept;
	public static boolean symbolAccept;
	
	public static boolean ignoreAutoComplete = false;
	public static boolean ignoreFilter = false;
	public static boolean disablePrediction;
	public static long vibrationLength;
	public static long[] vibrationPattern;
	public static boolean vibrationLengthToggle;
	static boolean noAutoCap;
	
	public static int currentLang;

	public static boolean altSymb;
	public static boolean spaceHack = true;
	public static boolean smileyHack = true;
	public static boolean androidSmileys = true;
	public static String volumeKeys;
	public static boolean hasVolumeAction;
	public static boolean showLang = false;
	public static boolean langShowed = false;

	public static Vibrator ownVibrator = null;
	public static Container lastContainer;
	public static HTCIMEService service;
	public static SharedPreferences prefs;
	public static float soundLevel;
	public static boolean soundLevelToggle;

	public static int inputType;
	public static EditorInfo editorInfo;
	public static boolean isOwnPackage;
	public static int t9mode;
	public static String lastWCL;

	public static int lastCustomPosition;
	public static int lastCustomPositionOrientation;

	public static int lastKB;
	public static int lastKBH;
	public static int lastHKBH;
	public static int lastO;
	public static float lastDensity = 1f;

	public static int lastScreenWidth;
	public static int lastScreenHeight;

	public static boolean replaceChars = false;
	public static String forbiddenChars = "";
	public static String replacementChars = "";

	/* Swipe stuff */
	public static boolean enableSwipe;
	public static int swipeThreshold;
	public static boolean swipePossible;	
	@SuppressWarnings("unchecked")
	public static Class[] onKeyDownParams = new Class[] { Integer.TYPE,
			Integer.TYPE, Integer.TYPE };
	
	public static View swipeView = null;
	
	public static Object onKeyDownView = null;
	public static int onKeyDownP1;
	public static int onKeyDownP2;
	public static int onKeyDownP3;
	
	public static Object onKeyMoveView = null;
	public static int onKeyMoveP1;
	public static int onKeyMoveP2;
	public static int onKeyMoveP3;
	
	static boolean insertWordPending = false;
	
	public static int lastUpdatedLang = -1;
	public static String lastUpdatedKB = "";

	/* Seems to be unused by HTC but is handled anyway */
	public static ArrayList<MediaPlayer> mediaPlayers = new ArrayList<MediaPlayer>();

	/* Main code starts here */

	/*
	 * Called from HTC init methods so we have a reference to the input service.
	 * Resets state
	 */
	public static void setService(InputMethodService s) {

		service = (HTCIMEService)s;
		prefs = null;

		lastCommit = "";
		lastCommitAppendedSpace = false;
		lastCommit = "";
		composing = false;
		lastSpaceTime = 0;
		lastCommaTime = 0;
		commaCount = 0;

		if (service != null) {
			Configuration c = service.getResources().getConfiguration();

			lastKB = c.keyboard;
			lastKBH = c.keyboardHidden;
			lastHKBH = c.hardKeyboardHidden;
			lastO = c.orientation;			

			WindowManager winMgr = (WindowManager) service
					.getSystemService(Context.WINDOW_SERVICE);
			DisplayMetrics metrics = new DisplayMetrics();
			winMgr.getDefaultDisplay().getMetrics(metrics);
			lastScreenWidth = metrics.widthPixels;
			lastScreenHeight = metrics.heightPixels;
			lastDensity = metrics.density;
			
			initFakeHW();
		}
	}

	/* Called from onStartInputView in the service. Sets up preferences etc. */
	
	public static void setEditorInfo(EditorInfo i) {
		onStartInputView(i, false);
	}
	
	public static void onStartInputView(EditorInfo i, boolean restarting) {

		gestureDetector.setIsLongpressEnabled(false);		
		swipeTracker.setDensity(lastDensity);

		inputType = i.inputType;
		editorInfo = i;

		lastCommit = "";
		lastCommitAppendedSpace = false;
		lastSpaceTime = 0;
		lastCommaTime = 0;
		commaCount = 0;
		lastCommit = "";
		composing = false;
		
		lastSelStart = 0;
		lastSelEnd = 0;
		currentLang = 0;
		String currentKB = "";
		
		CharSequence before = getTextBeforeCursor(Integer.MAX_VALUE);
		if(before != null)
			lastSelStart = before.length();
			
		lastSelEnd = lastSelStart;
		
		//log("start " + lastSelStart);
		
		voiceInserted = false;

		boolean enterSend = false;
		customDomainsToggle = false;
		ignoreAutoComplete = false;
		ignoreFilter = false;
		noAutoCap = false;
		showBar = true;
		ignoreSilentMode = false;
		soundLevel = -1f;
		soundLevelToggle = false;
		insertSpace = true;
		insertPeriod = true;
		insertSpaceAfterSeparator = true;
		insertSpaceAfterSmiley = true;
		insertSpaceAfterWord = true;
		predictInWords = false;
		predictAfterWords = true;
		insertAddedWord = true;
		volumeKeys = "none";
		hasVolumeAction = false;
		boolean alwaysPredictInBrowser = true;
		separatorAccept = true;
		spaceAccept = true;
		symbolAccept = true;

		leftAlign = false;
		noAutoAdd = false;
		t9mode = -1;
		customDelayToggle = false;
		customDelay = 750;
		swipeRight = 0;
		swipeDown = 0;
		swipeLeft = 0;
		swipeUp = 0;
		swipeWhenComposing = true;
		disablePreview = false;
		altSymb = false;
		
		forbiddenChars = "";
		replacementChars = "";
		
		predictInURL = false;
		disablePrediction = false;

		vibrationLength = 35;
		vibrationLengthToggle = false;

		replaceChars = false;
		boolean replaceCharsSMS = false;
		
		isOwnPackage = i.packageName != null && i.packageName.equals("jonasl.ime");
		

		if (service != null) {
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
			swipeThreshold = (int) (300 * service.getResources().getDisplayMetrics().density);
		} else
			swipeThreshold = 300;

		if (prefs != null) {
			
			customDomainsToggle = prefs.getBoolean("customDomainsToggle", customDomainsToggle);
			ignoreFilter = prefs.getBoolean("ignoreFilter", ignoreFilter);
			ignoreAutoComplete = prefs.getBoolean("ignoreAutoComplete",	ignoreAutoComplete);
			enterSend = prefs.getBoolean("enterSend", enterSend);
			showBar = prefs.getBoolean("showBar", showBar);
			noAutoCap = prefs.getBoolean("noAutoCap", noAutoCap);
			ignoreSilentMode = prefs.getBoolean("ignoreSilentMode",	ignoreSilentMode);
			String soundLevelString = prefs.getString("soundLevel", String.valueOf(soundLevel));
			insertSpace = prefs.getBoolean("insertSpace", insertSpace);
			predictInWords = prefs.getBoolean("predictInWords", predictInWords);
			predictAfterWords = prefs.getBoolean("predictAfterWords", predictAfterWords);
			leftAlign = prefs.getBoolean("leftAlign", leftAlign);
			noAutoAdd = prefs.getBoolean("noAutoAdd", noAutoAdd);
			customDelayToggle = prefs.getBoolean("customDelayToggle", customDelayToggle);
			soundLevelToggle = prefs.getBoolean("soundLevelToggle", soundLevelToggle);
			insertSpaceAfterSeparator = prefs.getBoolean("insertSpaceAfterSeparator", insertSpaceAfterSeparator);
			insertSpaceAfterSmiley = prefs.getBoolean("insertSpaceAfterSmiley", insertSpaceAfterSmiley);
			insertSpaceAfterWord = prefs.getBoolean("insertSpaceAfterWord", insertSpaceAfterWord);
			swipeRight = PrefsGestures.getActionCode(prefs.getString("swipeRight", "none"));
			swipeLeft = PrefsGestures.getActionCode(prefs.getString("swipeLeft", "none"));
			swipeUp = PrefsGestures.getActionCode(prefs.getString("swipeUp", "none"));
			swipeDown = PrefsGestures.getActionCode(prefs.getString("swipeDown", "none"));
			tripleComma = PrefsGestures.getActionCode(prefs.getString("tripleComma", "none"));			
			swipeWhenComposing = prefs.getBoolean("swipeWhenComposing", swipeWhenComposing);
			disablePreview = prefs.getBoolean("disablePreview", disablePreview);
			predictInURL = prefs.getBoolean("predictInURL", predictInURL);
			vibrationLengthToggle = prefs.getBoolean("vibrationLengthToggle", vibrationLengthToggle);
			alwaysPredictInBrowser = prefs.getBoolean("alwaysPredictInBrowser", alwaysPredictInBrowser);
			replaceChars = prefs.getBoolean("replaceChars", replaceChars);
			replaceCharsSMS = prefs.getBoolean("replaceCharsSMS", replaceCharsSMS);
			insertAddedWord = prefs.getBoolean("insertAddedWord", insertAddedWord);
			volumeKeys = prefs.getString("volumeKeys", volumeKeys);
			showLang = prefs.getBoolean("showLang", showLang);
			currentLang = Integer.valueOf(prefs.getString("keyboard_language", "0"));
			insertPeriod = prefs.getBoolean("insertPeriod", insertPeriod);
			
			separatorAccept = prefs.getBoolean("separatorAccept", separatorAccept); 
			spaceAccept = prefs.getBoolean("spaceAccept", spaceAccept);
			symbolAccept = prefs.getBoolean("symbolAccept", symbolAccept);
			
			altSymb = prefs.getBoolean("altSymb", altSymb);
			
			String customDelayString = prefs.getString("customDelay", String.valueOf(customDelay));
			String vibrationLengthString = prefs.getString("vibrationLength", String.valueOf(vibrationLength));
			
			forbiddenChars = prefs.getString("forbiddenChars", "");
			replacementChars = prefs.getString("replacementChars", "");
			
			hasVolumeAction = !volumeKeys.equals("none");
			currentKB = prefs.getString("keyboard_types", "error");

			try {
				soundLevel = Float.valueOf(soundLevelString);
				soundLevel = soundLevel / 100f;
			} catch (Exception ex) {
				soundLevel = -1f;
			}

			try {
				customDelay = Long.valueOf(customDelayString);
				if(customDelay < 100)
					customDelay = 100;
			} catch (Exception ex) {
				customDelay = 0;
			}		
			

			if (vibrationLengthToggle) {
				try {
					vibrationLength = Long.valueOf(vibrationLengthString);
				} catch (Exception ex) {
					vibrationLength = 35;
				}
			}
		}
		
		if(isOwnPackage)
			replaceChars = false;
		
		if (replaceChars) {			
			if (forbiddenChars.length() != replacementChars.length()) {
				log("warning: replace parameters have different lengths");
	
				int min = Math.min(forbiddenChars.length(), replacementChars.length());
	
				if (min > 0) {
					forbiddenChars = forbiddenChars.substring(0, min);
					replacementChars = replacementChars.substring(0, min);
					log("warning: using first " + min + " chars of replace parameters");
				} else {
					forbiddenChars = "";
					replacementChars = "";
					log("warning: ignoring replace parameters");
				}
			} else {
				//log("replace parameters loaded. count is " + forbiddenChars.length());
			}
			
			if (forbiddenChars.length() == 0 || forbiddenChars.length() != replacementChars.length()) {
				replaceChars = false;
				log("Char replacement disabled due to bad parameters");
			}
		}

		vibrationPattern = new long[] { 2, vibrationLength };

		enableSwipe = swipeRight > 0 || swipeLeft > 0 || swipeDown > 0 || swipeUp > 0;

		if (service != null && soundLevel >= 0f && soundLevel <= 1.0f) {

			AudioManager mgr = (AudioManager) service
					.getSystemService(Context.AUDIO_SERVICE);
			int max = mgr.getStreamMaxVolume(3);
			float value = (soundLevel * max) / 100f;

			for (int n = 0; n < mediaPlayers.size(); n++) {
				try {
					mediaPlayers.get(n).setVolume(value, value);
				} catch (Exception e) {

				}
			}
		}
		
		// Use this to dump info about the current field
		//logEditorInfo(i);

		if (alwaysPredictInBrowser)
			disablePrediction = false;
		
		if(isOwnPackage) {
			showBar = false;
			disablePrediction = true;
			insertSpace = false;
		}

		shiftEnter = false;
		forceAction = false;
		if (i.packageName != null
				&& i.packageName.startsWith("com.android.mms")
				&& (i.inputType & InputType.TYPE_TEXT_VARIATION_SHORT_MESSAGE) != 0) {
			if (enterSend)
				forceAction = true;
			else
				shiftEnter = true;
		}

		if ((i.inputType & InputType.TYPE_MASK_CLASS) == InputType.TYPE_CLASS_TEXT) {
			// log("text");
			
			if ((i.inputType & InputType.TYPE_MASK_FLAGS & InputType.TYPE_TEXT_FLAG_AUTO_COMPLETE) != 0) {
				if(ignoreAutoComplete) {
					if(!currentKB.equals("2"))
						insertSpace = false;
				}
				else {
					showLang = false;
					insertSpace = false;
				}
			}

			if (i.packageName != null
					&& i.packageName.toLowerCase().contains("copilot")) {
				ignoreAutoComplete = false;
				insertSpace = false;
				showLang = false;
				// log("disable ignoreAutoComplete copilot");
			}
			
			
			
			if ((i.packageName != null && i.packageName.equals("com.p1.chompsms")) ||
				(i.packageName != null && i.packageName.equals("com.handcent.nextsms")) ||
				(i.packageName != null && i.packageName.equals("com.android.mms")) ) {

				if(replaceChars) {
					
				}				
			}
			else {
				if(replaceCharsSMS) {					
					replaceChars = false;
				}
			}

			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_FILTER) {
				
				// log("disable space filter");
				if (ignoreFilter && i.packageName != null
						&& !i.packageName.toLowerCase().contains("copilot")) {
					i.inputType &= ~InputType.TYPE_TEXT_VARIATION_FILTER;
				}
				else {
					showLang = false;
					insertSpace = false;
				}
			}

			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_WEB_EDIT_TEXT) {
				boolean multiLine = (i.inputType & InputType.TYPE_MASK_FLAGS & InputType.TYPE_TEXT_FLAG_MULTI_LINE) != 0;
				if (!alwaysPredictInBrowser && !multiLine){
					disablePrediction = true;
					showLang = false;
					insertSpace = false;
				}
			}
			
			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_URI) {
				insertSpace = false;
				if(!predictInURL) {					
					disablePrediction = true;
					showLang = false;
				}
			}
			
			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_EMAIL_ADDRESS) {
				insertSpace = false;
				disablePrediction = true;
				showLang = false;
			}
			
			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_PASSWORD) {
				insertSpace = false;
				disablePrediction = true;
				showLang = false;
			}
			
			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_PHONETIC) {
				insertSpace = false;
				disablePrediction = true;
				showLang = false;
			}
			
			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD) {
				insertSpace = false;
				disablePrediction = true;
				showLang = false;
			}
			

			if (noAutoCap) {
				i.inputType &= ~InputType.TYPE_TEXT_FLAG_CAP_WORDS;
				i.inputType &= ~InputType.TYPE_TEXT_FLAG_CAP_SENTENCES;
			}

			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_PASSWORD) {
				insertSpace = false;
			}

			if ((i.inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD) {
				insertSpace = false;
			}
		} else {
			// log("not text");
			insertSpace = false;
			ignoreAutoComplete = false;
			showLang = false;
			replaceChars = false;
		}
		
		eventHandler.sendEmptyMessage(8);
	}
	
	/* Language stuff */
	
	public static void viewShown() {
		if(showLang) {
			
			boolean doIt = (inputType & InputType.TYPE_MASK_CLASS) == InputType.TYPE_CLASS_TEXT;
			
			if(langShowed)
				doIt = false;
			
			if(isOwnPackage)
				doIt = false;
			
			if(doIt) {
				String lang = prefs.getString("keyboard_language", "0");
				if(lang.length() > 0) {
					eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 6, PrefsLang.getLanguageName(service, lang)), 20);
					langShowed = true;
				}
			}
		}
	}
	
	public static void viewHidden() {
		langShowed = false;
	}	
	
	public static void changeLanguage(String id) {
		
		if(service == null)
			return;
		
		if(prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
		
    	prefs.edit().putString("keyboard_language", id).putInt("MODIFIED", 1).commit();		    	
		lastUpdatedLang = -1;		
    	eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 6, PrefsLang.getLanguageName(service, id)), 20);
    	eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 7), 200);
	}
	
	public static void cycleKeyboard() {
		
		if(service == null)
			return;
		
		if(prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
		
		String current = prefs.getString("keyboard_types", "error");
		String next = current;
		if(current.equals("2")) {
			if(prefs.getBoolean("kbCycleCQ", true))
				next = "0";
			else if(prefs.getBoolean("kbCycleP", true))				
				next = "1";
		}
		else if(current.equals("0")) {
			if(prefs.getBoolean("kbCycleP", true))
				next = "1";
			else if(prefs.getBoolean("kbCycleQ", true))				
				next = "2";
		}
		if(current.equals("1")) {
			if(prefs.getBoolean("kbCycleQ", true))
				next = "2";
			else if(prefs.getBoolean("kbCycleCQ", true))				
				next = "0";
		}
		
		if(!current.equals(next)) {
			lastUpdatedKB = "";
			prefs.edit().putString("keyboard_types", next).putInt("MODIFIED", 1).commit();
			eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 7), 200);
		}
	}
	
	public static void toggleQwertyPrediction() {
		if(service == null)
			return;
		
		if(prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
		
		boolean val = !prefs.getBoolean("keyboard_ime_settings_fqwerty_prediction", true);
		prefs.edit().putBoolean("keyboard_ime_settings_fqwerty_prediction", val).putInt("MODIFIED", 2).commit();
		eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 6, "Prediction " + (val ? "on" : "off")), 20);
    	eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 7), 200);
	}
	
	
	private static PopupWindow textPopup = null;
	private static TextView textPopupView = null;
	
	public static void showPopupText(String text) {
		if(service == null)
			return;
		try {
			
			eventHandler.removeMessages(5);
			
			int bgId = 0;
			View parent = null;		
		
			parent = (View)service.getClass().getField("mHTCIMMView").get(service);
			Class<?> c = Class.forName("com.htc.android.htcime.R$drawable");
			bgId = c.getField("accent_bg").getInt(null);		
		
			if(textPopup == null)
				textPopup = new PopupWindow(service);
			
			if(bgId > 0) 
				textPopup.setBackgroundDrawable(service.getResources().getDrawable(bgId));
			
			if(textPopupView == null) {
				textPopupView = new TextView(service);
				textPopup.setContentView(textPopupView);
				textPopupView.setTextSize(TypedValue.COMPLEX_UNIT_SP, 25);
				textPopupView.setGravity(Gravity.CENTER);
				textPopupView.setTextColor(Res.POPUPTEXT_COLOR);
			}
			
			textPopupView.setText(text);
			
			Paint paint = new Paint();
			paint.setTextSize(textPopupView.getTextSize());
			float width = paint.measureText(textPopupView.getText().toString());
			
			WindowManager winMgr = (WindowManager) service.getSystemService(Context.WINDOW_SERVICE);
			DisplayMetrics metrics = new DisplayMetrics();
			winMgr.getDefaultDisplay().getMetrics(metrics);
			
			int w = (int)(width + (metrics.density * 20));
			int h = (int)(metrics.density * 40);			
			
			if(textPopup.isShowing()) {				
				textPopup.update(0, 0, w, h);
			}
			else {
				textPopup.setWidth(w);
				textPopup.setHeight(h);
				textPopup.showAtLocation(parent, Gravity.TOP | Gravity.CENTER_HORIZONTAL, 0, 0);
			}
			
			eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 5), 1000);
			
		} catch (Exception ex) {
			log("showPopupText: " + ex.toString());
		}
		
	}
	
	/* Fix up the tutorial (it's buggy because of my mods but who cares really? */
	
	public static float fixTutoOffset(float y) {
		
		if(lastContainer != null) {
			if(y < 0)
				y += 2* lastContainer.getHeight();
			else
				y += lastContainer.getHeight();
		}
		
		return y;
	}
	
	public static int fixTutoOffset(int y) {		
		
		return (int)fixTutoOffset((float)y);
	}
	
	public static int fixTutoKeyIdx(int i) {
		if(smileyHack && i == -4)
			i = -16;
		return i;
	}	

	/* Called from HTC code */
	public static boolean getIsAutoComplete(boolean val) {
		boolean res = val;
		if (ignoreAutoComplete)
			res = false;
		else {
			if ((inputType & InputType.TYPE_MASK_CLASS) == InputType.TYPE_CLASS_TEXT) {
				if ((inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_URI) {
					if (predictInURL)
						res = false;
				}
			}
		}
		//log("getIsAutoComplete " + val + " -> " + res );
		return res;
	}
	
	public static boolean spaceAccept() {
		if(spaceAccept)
			return true;
		
		finishComposingText(false);
		commitText(" ");
		return false;
	}
	
	public static boolean separatorAccept(char c) {
		if(separatorAccept)
			return true;
		
		finishComposingText(false);
		commitText(String.valueOf(c));
		return false;
	}
	
	public static boolean symbolAccept() {
		if(symbolAccept)
			return true;
		
		finishComposingText(false);
		commitText("");
		return false;
	}

	/* Called from onCreateCandidatesView. Returns the custom word candidate bar */
	public static View getContainer() {

		if (service == null)
			return null;

		Container container = new Container(service);
		container.measure(View.MeasureSpec.makeMeasureSpec(0,
				View.MeasureSpec.UNSPECIFIED), View.MeasureSpec
				.makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED));

		int h = container.getMeasuredHeight();
		int w = container.getMeasuredWidth();

		Bitmap bitmapOrg;

		/* The resource ids points to keyboard backgrounds */

		int portbg = 0;
		int landbg = 0;

		try {
			Class<?> c = Class.forName("com.htc.android.htcime.R$drawable");
			portbg = c.getField("sapphire_port_background").getInt(null);
			landbg = c.getField("sapphire_land_background").getInt(null);
		} catch (Exception ex) {
			log("getContainer: " + ex.toString());
		}

		// log("getContainer: port:" + Integer.toHexString(portbg) + " land:" +
		// Integer.toHexString(landbg));

		if (portbg == 0 || landbg == 0) {
			return null;
		}

		if (service.getResources().getConfiguration().orientation == Configuration.ORIENTATION_PORTRAIT) {
			bitmapOrg = BitmapFactory.decodeResource(service.getResources(),
					portbg);
		} else {
			bitmapOrg = BitmapFactory.decodeResource(service.getResources(),
					landbg);
		}

		/* Scale the background to fit the bar */

		int org_w = bitmapOrg.getWidth();
		int org_h = bitmapOrg.getHeight();

		float scale_w = ((float) w) / org_w;
		float scale_h = ((float) h) / org_h;

		Matrix matrix = new Matrix();
		matrix.postScale(scale_w, scale_h);

		// Static.log("getContainer " + org_w + " " + org_h + " -> " + w + " " +
		// h);

		Bitmap bitmapResized = Bitmap.createBitmap(bitmapOrg, 0, 0, org_w,
				org_h, matrix, true);

		// Use reflection so we can support 1.5 that lacks the proper ctor
		BitmapDrawable bmd = null;
		try {
			Class<BitmapDrawable> c = BitmapDrawable.class;
			Constructor<BitmapDrawable> ctor = c.getDeclaredConstructor(
					Resources.class, Bitmap.class);
			bmd = ctor.newInstance(service.getResources(), bitmapResized);
		} catch (Exception ex) {
			// We are probably on Android 1.5 so it's safe to use this
			// deprecated ctor
			bmd = new BitmapDrawable(bitmapResized);
		}

		if (bmd != null)
			container.setBackgroundDrawable(bmd);

		lastContainer = container;
		return container;
	}

	/* Is the bar visible? */
	public static boolean lastContainerVisible() {

		boolean result = false;

		if (lastContainer != null) {
			FrameLayout parent = (FrameLayout) lastContainer.getParent();
			result = parent.getVisibility() == View.VISIBLE;
		}

		return result;
	}

	/* The x position of the candidate list */
	public static int getXPos(int x) {

		if (leftAlign)
			return 0;
		else
			return x;
	}

	/* Helper to the background hack on Droid */
	public static Bitmap getBitmap(Drawable d) {

		BitmapDrawable bd = (BitmapDrawable) d;
		return bd.getBitmap();
	}

	/* Called from HTC init code to determine if HW kb should be used */
	public static boolean useHWKeyboard() {

		if (fakeHW)
			return true;
		else {
			if (service == null)
				return false;

			boolean result = false;

			Configuration c = service.getResources().getConfiguration();

			if (c.orientation == Configuration.ORIENTATION_PORTRAIT) {
				result = false;
			} else {

				if (c.keyboard != Configuration.KEYBOARD_QWERTY)
					result = false;
				else {

					if (c.hardKeyboardHidden == Configuration.HARDKEYBOARDHIDDEN_NO)
						result = true;
					else
						result = false;
				}
			}

			return result;
		}
	}

	/* Called from HTC init code to determine if we are in full screen mode */
	public static boolean evaluateFullscreenMode() {

		if (fakeHW)
			return false;
		else {
			if (service == null)
				return false;

			boolean result = false;

			Configuration c = service.getResources().getConfiguration();

			if (c.orientation == Configuration.ORIENTATION_PORTRAIT) {
				result = false;
			} else {

				if (c.keyboard != Configuration.KEYBOARD_QWERTY)
					result = true;
				else {

					if (c.hardKeyboardHidden == Configuration.HARDKEYBOARDHIDDEN_NO)
						result = false;
					else
						result = true;
				}
			}

			return result;
		}
	}

	/* Called when configuration changes */
	public static boolean restartEditor(Configuration c) {

		boolean result = false;

		if (lastO != c.orientation) {
			result = true;
		}

		if (lastKB == Configuration.KEYBOARD_QWERTY) {
			if (lastHKBH != c.hardKeyboardHidden) {
				result = true;
			}
		}

		return result;
	}

	/* Gets the view width. Used to hack the keyboard onto the Droid */
	public static int getViewWidth(int m) {

		if (service == null)
			return m;

		int result = m;

		if (lastScreenWidth >= m)
			result = lastScreenWidth;

		return result;
	}

	/* Gets the background width. Used to hack the keyboard onto the Droid */
	public static Rect getBackgroundRect(Rect r) {

		r = new Rect(r);

		int m = r.width();

		if (lastScreenWidth >= m) {
			int diff = lastScreenWidth - m;
			r.right += diff;
		}

		return r;
	}

	/* Custom delay for secondary key popup */
	public static long getPopupDelay(long def) {
		long result = def;
		if (customDelayToggle && customDelay > 0)
			result = customDelay;

		return result;
	}

	/* My settings handling. Called from the HTC settings init code */
	
	public static void settingsDestroy() {
		PrefsLang.htcLangPref = null;
	}
	
	public static void injectPreference(PreferenceActivity a) {

		PreferenceScreen screen = a.getPreferenceScreen();
		for(int i = 0; i < screen.getPreferenceCount(); i++) {
			Preference p = screen.getPreference(i);			
			if(!(p instanceof PreferenceScreen))
				continue;
			
			PreferenceScreen s = (PreferenceScreen)p;
			if(p.getIntent() == null)
				continue;
			
			Intent it = s.getIntent();
			
			String className = it.getComponent().getClassName();
			String packageName = it.getComponent().getPackageName();			
			
			it.setClassName(packageName.replace("com.htc.android.htcime", "jonasl.ime"),
					className.replace("com.htc.android.htcime", "jonasl.ime"));
			s.setIntent(it);			
		}
		
		PrefsLang.htcLangPref = null;
		try {
			PrefsLang.htcLangPref = (ListPreference)a.getClass().getField("mLPLanguage").get(a);			
		}
		catch (Exception e) {
			log("htcLangPref " + e.toString());
		}

		PreferenceCategory cat = new PreferenceCategory(a);
		cat.setTitle("Mods by jonasl@xda (" + versionString + ")");
		screen.addPreference(cat);

		PreferenceScreen tmpScreen;
		Intent tmpIntent;

		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("User interface");
		tmpScreen.setSummary("Options for candidates, smileys...");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsUI");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Text input");
		tmpScreen.setSummary("Space insertion, popup delay...");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsTextInput");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Voice input");
		tmpScreen.setSummary("Voice button, voice server");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsVoice");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Gestures");
		tmpScreen.setSummary("Set swipe and other gesture actions");
		tmpIntent = new Intent();		
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsGestures");
		tmpScreen.setIntent(tmpIntent);		
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Prediction & dictionary");
		tmpScreen.setSummary("When and where to enable prediction and more");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsPreDict");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("User dictionary");
		tmpScreen.setSummary("Import, export and clear");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsUserDict");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Sound & vibration");
		tmpScreen.setSummary("Set volume and length");
		tmpIntent = new Intent();
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsSoundVibration");
		tmpScreen.setIntent(tmpIntent);
		screen.addPreference(tmpScreen);
		
		tmpScreen = a.getPreferenceManager().createPreferenceScreen(a);
		tmpScreen.setTitle("Language selection");
		tmpScreen.setSummary("Configure selectable languages for settings and gestures");
		tmpIntent = new Intent();		
		tmpIntent.setAction(Intent.ACTION_MAIN);
		tmpIntent.setClassName("jonasl.ime", "jonasl.ime.PrefsLang");
		tmpScreen.setIntent(tmpIntent);		
		screen.addPreference(tmpScreen);
		
		Preference killPref = new Preference(a);
		killPref.setTitle("Kill keyboard");
		killPref.setSummary("Commit suicide to apply certain changes");
		killPref.setOnPreferenceClickListener(new Preference.OnPreferenceClickListener() {
					public boolean onPreferenceClick(Preference p) {
						android.os.Process.killProcess(android.os.Process.myPid());
						return true;
					}
				});

		screen.addPreference(killPref);

	}
	
	/* User dictionary */
	
	/* HTC can't handle a completely empty dictionary. It then returns count -1 which causes FC */
	public static int fixWordCount(int cnt) {
		return Math.max(cnt, 0);
	}

	/* Swiping code */

	/* These are used to trigger case adjustments after swipe left to delete */
	public static Object sipObj = null;
	
	public static void setSipObj(Object o) {
		sipObj = o;
	}
	
	/* Used to detect swiping */
	private static SwipeTracker swipeTracker = new SwipeTracker();
	
	public static GestureDetector gestureDetector = new GestureDetector(
			service, new GestureDetector.SimpleOnGestureListener() {
				@Override
				public boolean onFling(MotionEvent me1, MotionEvent me2,
						float velocityX, float velocityY) {
					
					//log("fling " + swipePossible);
					
					eventHandler.removeMessages(0);

					if (swipePossible) {

						/* Copied from stock kb */
						
						final float absX = Math.abs(velocityX);
						final float absY = Math.abs(velocityY);
						
						float lX = swipeTracker.startLimit * 2f; //swipeView.getWidth() / 4;
						float lY = swipeTracker.startLimit * 1.5f; //swipeView.getHeight() / 5;
						
						float deltaX = me2.getX() - me1.getX();
						float deltaY = me2.getY() - me1.getY();
						
						float distX = Math.abs(swipeTracker.distX);
						float distY = Math.abs(swipeTracker.distY);
						
						
						/*log("vX:" + velocityX + " vY:" + velocityY +  
								" dX:" + deltaX + " dY:" + deltaY + 
								" tX:" + distX + " tY:" + distY +
								" lX:" + lX + " lY:" + lY + " t:" + swipeThreshold);*/

						if (velocityX > swipeThreshold && absY < absX / 2 && distX > 1.4 * distY
								&& deltaX > lX && distX > swipeTracker.startLimit) {
							
							if(swipeRight > 0 && performGesture(swipeRight)) {

								onKeyDownView = null;
								onKeyMoveView = null;
								return true;
							}
							
							sendDelayedOnKeyDown();
							return false;

						} else if (velocityX < -swipeThreshold && absY < absX / 2
								&& deltaX < -lX && distX > swipeTracker.startLimit) {
							
							if(swipeLeft > 0 && performGesture(swipeLeft)) {
								
								onKeyDownView = null;
								onKeyMoveView = null;
								return true;
							}							
							
							sendDelayedOnKeyDown();
							return false;

						} else if (velocityY < -swipeThreshold && absX < absY / 2
								&& deltaY < -lY && distY > swipeTracker.startLimit) {
							
							if(swipeUp > 0 && performGesture(swipeUp)) {
								
								onKeyDownView = null;
								onKeyMoveView = null;
								return true;
							}							
							
							sendDelayedOnKeyDown();
							return false;

						} else if (velocityY > swipeThreshold && absX < absY / 2
								&& deltaY > lY && distY > swipeTracker.startLimit) {
							
							if(swipeDown > 0 && performGesture(swipeDown)) {
								
								onKeyDownView = null;
								onKeyMoveView = null;
								return true;
							}
							
							sendDelayedOnKeyDown();
							return false;
						}
						
						//log("fling not a swipe >");
						sendDelayedOnKeyDown();
						return false;
					} else {
						//log("fling not a swipe <");
						sendDelayedOnKeyDown();
						return false;
					}
				}
			});
	
	private static boolean performGesture(int action) {
		
		switch (action) {
		case 1: // Delete last word
			deleteLastWord();
			return true;
		case 2:
			deleteLastSentence();
			return true;
		case 3:
			moveAfterWord();
			return true;
		case 4: // Hide
			try {
				try {
					if(textPopup != null) {
						textPopup.dismiss();
					}
				}catch (Exception e) {
				}
				textPopup = null;
				textPopupView = null;
				Method hideMethod = service.getClass().getMethod("hideKB", (Class[])null);
				hideMethod.invoke(service, (Object[])null);				
			}
			catch(Exception ex) {
				log("hide failed: " + ex.toString());
			}
			
			return true;
		case 5: //Shift
			try {
				Object kbO = swipeView.getClass().getField("mKeyboard").get(swipeView);
				int shiftIdx =  (Integer)kbO.getClass().getMethod("getShiftKeyIndex", (Class[])null).invoke(kbO, (Object[])null);
				sendOnKeyDown(swipeView, shiftIdx, 0, 0);
				sendOnKeyUp(swipeView, shiftIdx, 0, 0);									
			}
			catch(Exception ex) {
				log("up: " + ex.toString());
				ex.printStackTrace();
			}
			
			return true;
		case 6: // Voice
			if(!composing) {
				startVoiceInput();
				return true;
			}
			return false;		
		case 7: // Cycle language
			changeLanguage(PrefsLang.getNextLanguage(service));
			return true;
			
		case 8: // Cycle kb
			cycleKeyboard();
			return true;
		
		case 9:
			toggleQwertyPrediction();
			return true;
		}
		
		return false;
	}

	/* Called when secondary keys popup */
	public static void disableSwipe() {
		//log("disableSwipe");
		swipePossible = false;
		sendDelayedOnKeyDown();
	}
		
	/* Called for all touch events */
	public static void onTouchEvent(View v, MotionEvent e) {	
	
		if (enableSwipe) {
			swipeView = v;
			
			final int action = e.getAction();
			if (action == MotionEvent.ACTION_DOWN)
				swipeTracker.clear(e.getX(), e.getY());

			switch (action) {
			case MotionEvent.ACTION_DOWN:
				swipePossible = swipeWhenComposing ? true : !composing;
				
				onKeyDownView = null;
				onKeyMoveView = null;
				break;
			case MotionEvent.ACTION_UP:

				break;
			case MotionEvent.ACTION_MOVE:
				if(swipeTracker.addMovement(e))
					disableSwipe();
				
				break;
			}
		}
	}
	
	public static void keyChanged() {		
		eventHandler.removeMessages(0);
		//log("keyChanged");
	}

	public static void sendOnKeyDown(Object o, int p1, int p2, int p3)
			throws Exception, NoSuchMethodException {
		
		Method m = o.getClass().getMethod("onKeyDown", onKeyDownParams);
		m.invoke(o, p1, p2, p3);		
	}
	
	public static void sendOnKeyMove(Object o, int p1, int p2, int p3)
		throws Exception, NoSuchMethodException {
		Method m = o.getClass().getMethod("onKeyMove", onKeyDownParams);
		m.invoke(o, p1, p2, p3);
}

	public static void sendOnKeyUp(Object o, int p1, int p2, int p3)
			throws Exception, NoSuchMethodException {
		
		if(htcKeyDownHandler != null && htcKeyDownMessage != null)
			htcKeyDownHandler.removeMessages(htcKeyDownMessage.what);
		
		Method m = o.getClass().getMethod("onKeyUp", onKeyDownParams);
		m.invoke(o, p1, p2, p3);
	}
	
	final static long swipeDelay = 80;

	/*
	 * Called by KeyboardView instead of calling onKeyDown immediately. Can
	 * delay keydown events
	 */
	public static void delegateOnKeyDown(Object o, int p1, int p2, int p3) {
		
		//log("delegateOnKeyDown " + p1 + " " + p2 + " " + p3);
		
		try {
			playKeyClick(p1);
			keyVibrationEffect();
			
			if (enableSwipe && swipePossible) {
				onKeyDownView = o;
				onKeyDownP1 = p1;
				onKeyDownP2 = p2;
				onKeyDownP3 = p3;				
				eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 0), swipeDelay);
			} else {
				onKeyDownView = null;
				sendOnKeyDown(o, p1, p2, p3);
				sendKeyDownHandlerMessage(0);
			}
		} catch (Exception ex) {
			log("delegateOnKeyDown fail (" + p1 + "," + p2 + "," + p3 + ") "
					+ ex.getMessage());
		}
	}
	
	public static Handler eventHandler = new Handler() {

		public void handleMessage(Message msg) {

			switch (msg.what) {
			case 0:
				if (onKeyDownView == null) {
					log("onKeyDownHandler view is null");
					return;
				}
	
				try {
					//log("handler");
					disableSwipe();
					sendKeyDownHandlerMessage(swipeDelay);
				} catch (Exception ex) {
					log("onKeyDownHandler fail: " + ex.getMessage());
				} finally {
					onKeyDownView = null;
				}
				break;
				
			case 1:
				if(msg.obj != null) {
					composing = true;
					String text = msg.obj.toString();
					if(newWordStart > -1)
						setEditSelection(newWordStart, newWordStart);
					newWordStart = -1;
					if(insertAddedWord)
						commitText(text);
					else
						commitText("");
					
					insertWordPending = false;
				}
					
				break;
			case 2:
				updateFullScreenMode();				
				break;
			
			case 3:
				try {					
					InputMethodManager mgr = (InputMethodManager)service.getSystemService(Context.INPUT_METHOD_SERVICE);
					mgr.showSoftInput((View)msg.obj, InputMethodManager.SHOW_IMPLICIT);
				}
				catch (Exception e) {
					log("showKb: " + e.toString());
				}
				break;
			case 4:
				if (service == null)
					return;

				if (prefs == null)
					prefs = PreferenceManager.getDefaultSharedPreferences(service);

				String key = "custom_position_2_" + lastCustomPositionOrientation
						+ "_" + showBar + "_" + lastHKBH;
				prefs.edit().putInt(key, lastCustomPosition).commit();
				
				break;
				
			case 5:
				try {
					if(textPopup != null) {
						textPopup.dismiss();
					}
				}catch (Exception e) {
				}
				textPopup = null;
				textPopupView = null;
				break;
			case 6:
				if(msg.obj != null)
					showPopupText(msg.obj.toString());
				break;
			case 7:
				service.onStartInputView(editorInfo, true);
				break;
			case 8:
				updateKeys();
				break;
			}
			
		}
	};
	
	/*
	 * Called by KeyboardView instead of calling onKeyMove immediately.
	 */
	public static void delegateOnKeyMove(Object o, int p1, int p2, int p3) {
		
		//log("delegateOnKeyMove " + p1 + " " + p2 + " " + p3);
		
		try {
			playKeyClick(p1);
			keyVibrationEffect();
			
			if (enableSwipe) {				
				eventHandler.removeMessages(0);

				onKeyMoveView = o;
				onKeyMoveP1 = p1;
				onKeyMoveP2 = p2;
				onKeyMoveP3 = p3; 
			}
			else {				
				sendOnKeyMove(o, p1, p2, p3);
			}
		} catch (Exception ex) {
			log("delegateOnKeyMove fail (" + p1 + "," + p2 + "," + p3 + ") "
					+ ex.toString());
		}
	}
	
	/* Enables pseudo multi touch for more keys than standard letters */
	public static boolean isAlphabetForKeyMove(Object key) {
		
		int[] codes = getCodes(key);
		if(codes == null || codes.length == 0)
			return false;
		
		int c = codes[0];
		
		//log("isAlphabetForKeyMove " + c);
		
		if(Character.isLetter(c))
			return true;
		
		switch(c) {
		case 0x20: //KEYCODE_SPACE
		case 0x2e: //KEYCODE_PERIOD
		case 0x2c: //KEYCODE_COMMA
		case 0x5d: //KEYCODE_UNDERLINE
		case 0x2f: //KEYCODE_SLASH
		case 0x27: //KEYCODE_QUOTE
		case 0x3f: //KEYCODE_QUESTION
		case 0x2b: //KEYCODE_PLUS
		case 0x2d: //KEYCODE_MINUS
		case 0x3d: //KEYCODE_EQUALS
		case 0x21: //KEYCODE_EXCLAMATION
		case 0x40: //KEYCODE_AT
		case 0x2a: //KEYCODE_ASTERISK
			return true;
		}
		
		return false;		
	}

	/*
	 * Called by KeyboardView instead of calling onKeyUp immediately. Sends
	 * delayed keydown events if any
	 */
	public static void delegateOnKeyUp(Object o, int p1, int p2, int p3) {
		
		//log("delegateOnKeyUp " + p1 + " " + p2 + " " + p3);
		
		try {
			if (enableSwipe) {				
				eventHandler.removeMessages(0);

				if (onKeyDownView != null) {
					sendOnKeyDown(o, onKeyDownP1, onKeyDownP2, onKeyDownP3);
				}
				
				if (onKeyMoveView != null) {					
					sendOnKeyMove(o, onKeyMoveP1, onKeyMoveP2, onKeyMoveP3);
				}
			}

			sendOnKeyUp(o, p1, p2, p3);
		} catch (Exception ex) {
			log("delegateOnKeyUp fail (" + p1 + "," + p2 + "," + p3 + ") "
					+ ex.toString());
			
			ex.printStackTrace();
		} finally {
			onKeyDownView = null;
			onKeyMoveView = null;
		}
	}

	public static void sendDelayedOnKeyDown() {
		try {
			if (onKeyDownView != null) {
				sendOnKeyDown(onKeyDownView, onKeyDownP1, onKeyDownP2,
						onKeyDownP3);
			}
		} catch (Exception ex) {
			log("sendDelayedOnKeyDown fail " + ex.getMessage());
		} finally {
			onKeyDownView = null;
		}
	}

	/* Called from HTC code to disable onKeyMove if swiping */
	public static boolean hasDelayedOnKeyDown() {
		log("hasDelayedOnKeyDown " + onKeyDownView != null);
		return onKeyDownView != null;
	}
	
	/* This is used to try and work around HTC code being laggy sometimes.
	 * The long press timer is started before the prediction gets the keydown
	 * event. If handling of it takes time the long press popup is shown
	 * too early. Instead of posting the message to the handler it calls
	 * setKeyDownHandlerMessage which stores it. When the keydown handler
	 * is called, I call sendKeyDownHandlerMessage.
	 * This way lagginess should'nt cause so much trouble.
	 * */
	
	static Handler htcKeyDownHandler = null;
	static Message htcKeyDownMessage = null;
	static long htcKeyDownDelay = -1;
	static boolean htcKeyDown = false;
	
	public static void setKeyDownHandlerMessage (Handler h, Message m, long delay) {
		htcKeyDownHandler = h;
		htcKeyDownMessage = m;
		htcKeyDownDelay = delay;
		htcKeyDown = true;
		//log("setKeyDownHandlerMessage " + m.what);
	}
	
	public static void sendKeyDownHandlerMessage(long ownDelay) {
		if(htcKeyDown && htcKeyDownHandler != null && htcKeyDownMessage != null && htcKeyDownDelay > 0) { 
			long delay = Math.max(10, htcKeyDownDelay - ownDelay);
			htcKeyDownHandler.sendMessageDelayed(htcKeyDownMessage, delay);
			//log("keyDown lag " + htcKeyDownDelay + " " + delay);
		}
		
		htcKeyDown = false;		
	}
	
	static Class<?>[] playKeyClickArgType = new Class[] {int.class};
	static Object[] playKeyClickArgs = new Object[1];
	@SuppressWarnings("unchecked")
	public static void playKeyClick(int index) {
		try {			
			Field f = sipObj.getClass().getField("mKeys");
			Object mKeys = f.get(sipObj);
			int code = -1;
			try {
				Object[] keys = (Object[])mKeys;
				code = getCodes(keys[index])[0];
			}
			catch (Exception e) {
				List<Object> keys = (List<Object>)mKeys;
				code = getCodes(keys.get(index))[0];
			}
			playKeyClickArgs[0] = code;
			sipObj.getClass().getMethod("playKeyClick", playKeyClickArgType).invoke(sipObj, playKeyClickArgs);
		}
		catch (Exception e) {
			log("playKeyClick: " + e.toString());
		}
	}
	
	public static void keyVibrationEffect() {
		
		try {
			sipObj.getClass().getMethod("VibrationEffect", (Class[])null).invoke(sipObj, (Object[])null);
		}
		catch (Exception e) {
			log("keyVibrationEffect: " + e.toString());
		}
	}
	
	public static void updateFullScreenMode() {
		try {
			//log("calling updateFullScreenMode");
			sipObj.getClass().getMethod("updateFullscreenMode", (Class[])null).invoke(sipObj, (Object[])null);
		}
		catch (Exception e) {
			log("updateFullScreenMode: " + e.toString());
		}
	}
	

	/* Saving the position of word candidate list */

	/* Called from HTC code when position changes */
	public static void setCustomPosition(int orientation, int position) {

		lastCustomPosition = position;
		lastCustomPositionOrientation = orientation;
		
		eventHandler.removeMessages(4);
		eventHandler.sendMessageDelayed(Message.obtain(eventHandler, 4), 200);
	}

	/* Called from HTC code when the word candidate list is about to show */
	public static int getCustomPosition(int orientation, int htcval) {

		lastCustomPositionOrientation = orientation;
		int def = orientation == 0 ? -3 : htcval;

		if (service == null)
			return def;

		if (prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);

		String key = "custom_position_2_" + lastCustomPositionOrientation + "_"
				+ showBar + "_" + lastHKBH;
		int res = prefs.getInt(key, def);

		return res;
	}

	/* Sound stuff. Called from HTC code */

	public static void addMediaPlayer(MediaPlayer mp) {
		mediaPlayers.add(mp);
		mp.setAudioStreamType(getStreamType());
	}

	public static int getStreamType() {

		int res = 1;
		if (service != null) {
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
			if (prefs.getBoolean("ignoreSilentMode", false))
				res = 3;
		}
		return res;
	}

	public static boolean soundOff(boolean silentMode) {

		if (!silentMode)
			return false;

		return silentMode && !ignoreSilentMode;
	}

	public static float getVolume(float volume) {

		float res;
		if (soundLevelToggle && soundLevel >= 0f && soundLevel <= 1.0f)
			res = soundLevel;
		else
			res = volume;

		return res;
	}
	
	public static int loadSound(SoundPool pool, Context context, int resId, int priority) {
		if(prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(context);
		
		boolean customSounds = prefs.getBoolean("customSounds", false);
		if(!customSounds)
			return pool.load(context, resId, priority);
		
		int effect_tick = -1;
		int keypressdelete = -1;
		int keypressreturn = -1;
		int keypressspacebar = -1;
		
		try {
			Class<?> c = Class.forName("com.htc.android.htcime.R$raw");
			effect_tick = c.getField("effect_tick").getInt(null);
			keypressdelete = c.getField("keypressdelete").getInt(null);
			keypressreturn = c.getField("keypressreturn").getInt(null);
			keypressspacebar = c.getField("keypressspacebar").getInt(null);
		} catch (Exception ex) {
			log("loadSound: " + ex.toString());
		}
		
		String fileName = null;
		String type = "";
		if(resId == effect_tick) {
			fileName = prefs.getString("keySoundNormal", "").trim();
			type = "effect_tick";
		}
		else if(resId == keypressdelete) {
			fileName = prefs.getString("keySoundBackspace", "").trim();
			type = "keypressdelete";	
		}
		else if(resId == keypressreturn) {
			fileName = prefs.getString("keySoundEnter", "").trim();
			type = "keypressreturn";
		}
		else if(resId == keypressspacebar) {
			fileName = prefs.getString("keySoundSpace", "").trim();
			type = "keypressspacebar";
		}
		if(fileName != null && fileName.length() > 0) {
			log("Trying to load '" + fileName + "' for " + type);
			File f = new File(fileName);
			if(f.exists() && f.canRead()) {
				try { 
					int res = pool.load(fileName, priority);
					log("SoundPool.load returned " + res);
					return res;
				}
				catch (Exception e) {
					log("loadSound: " + e.toString());
				}
			}
			else {
				log("Unable to read file " + fileName);
			}
		}
		log("Using default sound for " + type);
		return pool.load(context, resId, priority);
	}

	/* Vibration */

	private static Vibrator getVibrator(Vibrator v) {

		if (ownVibrator != null) {
			v = ownVibrator;
		}
		else {
			if (service != null) {
				ownVibrator = (Vibrator) service
						.getSystemService(Context.VIBRATOR_SERVICE);
			}

			if (ownVibrator != null) {
				v = ownVibrator;
			}
		}

		return v;
	}

	public static void vibrate(Vibrator v) {

		// log("vibrate: " + vibrationLength);

		v = getVibrator(v);

		if (v != null) {
			v.cancel();
			v.vibrate(vibrationPattern, -1);
		}
	}

	public static void vibrate(Vibrator v, long[] pattern, int repeat) {

		// log("vibrate: " + Arrays.toString(pattern) + " " + repeat);

		v = getVibrator(v);

		if (v != null) {
			v.cancel();
			v.vibrate(pattern, repeat);
		}
	}

	/* Voice input stuff */

	/* Call this to start voice input whenever */
	@SuppressWarnings("unchecked")
	public static void startVoiceInput() {
		try {
			Class c = Class
					.forName("com.htc.android.htcime.voice.FieldContext");
			Class partypes[] = new Class[] { InputConnection.class,
					EditorInfo.class };
			Constructor ctor = c.getConstructor(partypes);
			Object fieldContext = ctor.newInstance(service
					.getCurrentInputConnection(), service
					.getCurrentInputEditorInfo());

			Method getVoiceInputMethod = null;
			for (Method m : service.getClass().getMethods()) {
				if (m.getName().equals("getVoiceInput")) {
					getVoiceInputMethod = m;
					break;
				}
			}

			if (getVoiceInputMethod == null)
				log("startVoiceInput: getVoiceInputMethod is null, gonna crash");

			Object voiceInput = getVoiceInputMethod.invoke(service,
					(Object[]) null);

			Method startListeningMethod = null;
			for (Method m : voiceInput.getClass().getMethods()) {
				if (m.getName().equals("startListening")) {
					startListeningMethod = m;
					break;
				}
			}

			if (startListeningMethod == null)
				log("startVoiceInput: startListeningMethod is null, gonna crash");

			startListeningMethod.invoke(voiceInput, fieldContext);
		} catch (Throwable e) {
			log("startVoiceInput: " + e.getMessage());
		}
	}

	/*
	 * Called from keyboard init to determine if voice button should be shown.
	 * The original voice hack.
	 */
	public static boolean showVoiceButton(int language) {

		// log("showVoiceButton");

		if (service == null)
			return false;

		if (prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);

		String voiceButton = prefs.getString("voiceButton", "english");
		
		if(voiceButton.equals("english"))
			return language == 0;
		else if (voiceButton.equals("most"))
			return true;
		
		return false;		
	}

	/*
	 * Adds some extras to the Intent present in stock kb but not in HTC kb.
	 * Also sets alt. server
	 */
	public static void setStockExtras(Intent i) {

		boolean useAltServer = false;

		if (service == null)
			return;

		if (prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);

		useAltServer = prefs.getBoolean("useAltServer", useAltServer);

		if (useAltServer)
			i.putExtra("android.speech.extras.SERVER_URL",
					"http://gjm.google.com/speechservice-dev?sky=rad");

		i.putExtra("android.speech.extras.SPEECH_INPUT_MINIMUM_LENGTH_MILLIS",
				(long) 0);
		i.putExtra("android.speech.extras.SPEECH_INPUT_COMPLETE_SILENCE_LENGTH_MILLIS",
				(long) 1000);
		i.putExtra("android.speech.extras.SPEECH_INPUT_POSSIBLY_COMPLETE_SILENCE_LENGTH_MILLIS",
				(long) 0);
	}

	/* T9 and prediction bug fixes */

	public static boolean getT9Mode(boolean def) {

		boolean result;

		if (t9mode == -1)
			result = def;
		else if (t9mode == 0)
			result = false;
		else
			result = true;

		return result;
	}

	public static void setT9Mode(boolean val) {
		if (val)
			t9mode = 1;
		else
			t9mode = 0;
	}

	public static void setWCL(Object o) {
		
		if (o != null)
			lastWCL = o.toString();
		else
			lastWCL = null;
	}
	
	public static void clearWCL() {
		lastWCL = null;
	}

	public static String getWCL(int index, String def) {

		if (def != null)
			return def;

		if (lastWCL == null)
			return null;
		try {
			String[] arr = lastWCL.split("\\|");
			return arr[index];
		} catch (Exception ex) {
			log("getWCL failed: " + ex.getMessage());
		}

		return null;
	}

	/*
	 * Text input hacks. Space and period insertion etc. All calls from HTC code
	 * to InputConnection are modified so that they go here so we can change
	 * stuff.
	 */

	public static String separators = ".,;:!?";
	public static String frenchSeparators = ":!?";
	public static boolean composing;
	public static CharSequence lastCommit;
	public static boolean lastCommitAppendedSpace;
	public static boolean lastCommitWasSpace;
	public static long lastSpaceTime = 0;
	public static long lastCommaTime = 0;
	public static int commaCount = 0;
	static boolean voiceInserted;

	/* Voice text capping */
	public static String fixVoiceText(String text) {

		if (text == null || text.length() == 0)
			return text;

		int cap = getCursorCapsMode(inputType);
		if (cap > 0) {
			Character c = Character.toUpperCase(text.charAt(0));
			if (text.length() == 1)
				text = c.toString();
			else
				text = c.toString() + text.substring(1);
		}

		return text;
	}

	/* Prediction hacks */
	public static boolean startPrediction(KeyEvent e) {
		if (disablePrediction) {
			return false;
		}

		boolean res = true;
		// Never in passwords
		if ((inputType & InputType.TYPE_MASK_CLASS) == InputType.TYPE_CLASS_TEXT) {
			if ((inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_PASSWORD) {
				return false;
			}
		}

		if (!predictInWords && !predictAfterWords) {
			CharSequence before = getTextBeforeCursor(1);
			if (before == null || before.length() == 0)
				res = true;
			else {
				char c = before.charAt(0);
				if (Character.isLetterOrDigit(c))
					res = false;
				else
					res = true;
			}
		} else {
			// TODO find out what key is being pressed

			CharSequence before = getTextBeforeCursor(1);
			CharSequence after = getTextAfterCursor(1);

			if (before == null)
				before = "";

			if (after == null)
				after = "";

			boolean hasBefore = before.length() > 0
					&& Character.isLetterOrDigit(before.charAt(0));
			boolean hasAfter = after.length() > 0
					&& Character.isLetterOrDigit(after.charAt(0));

			boolean isAfterWord = hasBefore && !hasAfter;
			boolean isInsideWord = hasBefore && hasAfter;

			if (!isAfterWord && !isInsideWord)
				res = true;
			else if (predictInWords && isInsideWord)
				res = true;
			else if (isAfterWord && predictAfterWords)
				res = true;
			else
				res = false;
		}

		// log("startPrediction:" + res);

		return res;
	}

	public static void setComposingText(CharSequence text, int newCursorPosition) {

		//log("setComposingText:'" + text + "'" + newCursorPosition);
		//logStackTrace();

		if (replaceChars)
			text = removeForbiddenChars(text);

		if (service == null) {
			log("setComposingText: service is null");
			return;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("setComposingText: connection is null");
			return;
		}

		composing = text.length() > 0;
		connection.setComposingText(text, 1);
	}

	public static boolean lastCommitWasSeparator() {

		if (lastCommit == null || lastCommit.length() == 0)
			return false;

		return separators.indexOf(lastCommit.charAt(lastCommit.length() - 1)) > -1;
	}

	public static void insertSpace() {

		if (service == null) {
			log("insertSpace: service is null");
			return;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("insertSpace: connection is null");
			return;
		}

		connection.finishComposingText();
		connection.commitText(" ", 1);
	}

	public static void commitText(CharSequence text) {
		commitText(text, 1);
	}

	public static CharSequence removeForbiddenChars(CharSequence text) {

		char[] chars = null;
		SpannableStringBuilder sb = null;
		if (text instanceof String) {
			chars = ((String) text).toCharArray();
		} else if (text instanceof SpannableStringBuilder) {
			chars = new char[text.length()];
			sb = (SpannableStringBuilder) text;
			chars = sb.toString().toCharArray();
		}

		if (chars != null) {
			int j;
			boolean replaced = false;
			for (int i = 0; i < chars.length; i++) {
				char c = chars[i];
				boolean upper = Character.isUpperCase(c);
				c = Character.toLowerCase(c);
				j = forbiddenChars.indexOf(c);
				if (j >= 0) {
					chars[i] = upper ? Character.toUpperCase(replacementChars
							.charAt(j)) : replacementChars.charAt(j);
					replaced = true;
				}
			}

			if (replaced) {
				if (sb != null) {
					Object[] spans = sb.getSpans(0, sb.length(), Object.class);
					sb.replace(sb.getSpanStart(spans[0]), sb
							.getSpanEnd(spans[0]), new String(chars));
					text = sb;
				} else
					text = new String(chars);
			}
		}

		return text;
	}
	
	public static int lastSelStart = 0;
	public static int lastSelEnd = 0;
	
	public static int newWordStart = -1;	
		
	public static void showKb(View v) {		
		Message msg = Message.obtain(eventHandler, 3, v);
		eventHandler.sendMessageDelayed(msg, 200);		
	}
	
	/* Called from  HTCIMEService.onUpdateSelection */
	public static void setSelection(int s, int e) {
		//log("setSelection " + s + "," + e);
		lastSelStart = s;
		lastSelEnd = e;	
		
		//log( insertWordPending + " " + isOwnPackage + " " + lastCommitWasEmpty);
		
		if(!insertWordPending && !isOwnPackage && lastCommitWasEmpty && !isWebEdit()) {
			newWordStart = s;
			//log("newWordStart " + s);			
		}
	}
	
	/* These are used for moving the cursor to correct position */
	public static void insertNewWord(String word) {
		//log("new word");
		
		insertWordPending = true;
		Message msg = Message.obtain(eventHandler, 1, word);
		eventHandler.sendMessageDelayed(msg, 200);
		
	}
	
	public static void insertWordCancel() {
		//log("insertWordCancel");
		insertWordPending = true;
		Message msg = Message.obtain(eventHandler, 1, "");
		eventHandler.sendMessageDelayed(msg, 200);
	}
	
	public static void setEditSelection(int start, int end) {
		
		//log("setEditSelection " + start + "," + end);
		if (service == null) {
			log("setSelection: service is null");

			composing = false;
			lastCommitAppendedSpace = false;
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}
		
		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("setEditSelection: connection is null");

			composing = false;
			lastCommitAppendedSpace = false;
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}
		
		try {
			connection.setSelection(start, end);
		}
		catch (Exception e) {
			log("setEditSelection fail: " + e.toString());
		}
	}
	
	public static boolean lastCommitWasEmpty = false;
	public static void commitText(CharSequence text, int newCursorPosition) {

		//log("commitText: '" + text + "' space=" + insertSpace );
		//logStackTrace();
		
		if (service == null) {
			log("commitText: service is null");

			composing = false;
			lastCommitAppendedSpace = false;
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("commitText: connection is null");

			composing = false;
			lastCommitAppendedSpace = false;
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}
		
		if (replaceChars)
			text = removeForbiddenChars(text);

		String t = text.toString();
		boolean appendSpace = false;
		boolean deleteSpace = false;
		boolean appendPeriod = false;

		if (insertPeriod && t.equals(" ")) {

			long diff = android.os.SystemClock.uptimeMillis() - lastSpaceTime;

			if (diff < 2000) {

				CharSequence prevSequence = getTextBeforeCursor(2);
				String prev = prevSequence == null ? "" : prevSequence.toString();
				if (prev.length() >= 2) {
					if (prev.charAt(prev.length() - 1) == ' '
							&& Character.isLetterOrDigit(prev.charAt(prev
									.length() - 2))) {
						appendPeriod = true;
						deleteSpace = true;
						text = "";
						// log("setting appendPeriod");
					}
				}
			}
		}
		
		if(tripleComma > 0 && commaCount >= 2 && t.trim().endsWith(",") && (SystemClock.uptimeMillis() - lastCommaTime) < 1000) {
			lastCommaTime = 0;
			commaCount = 0;
			connection.beginBatchEdit();
			deleteCommas(2);
			performGesture(tripleComma);
			connection.endBatchEdit();
			return;
		}

		if (insertSpace && !appendPeriod) {
			boolean isSeparator = t.trim().length() == 1
					&& separators.contains(t.trim());
			//log("composing=" + composing + " isSeparator=" + isSeparator + " lastCommitAppendedSpace=" + lastCommitAppendedSpace);
			if (composing && !isSeparator) {
				if (t != "" && !t.endsWith(" ")) {

					int ii = separators.indexOf(t.charAt(t.length() - 1));
					if((ii < 0 && insertSpaceAfterWord) || (ii >= 0 && insertSpaceAfterSeparator)) {					
						appendSpace = true;
						lastCommitAppendedSpace = true;
					}
				} else if (t.endsWith(" "))
					lastCommitAppendedSpace = true;
				else
					lastCommitAppendedSpace = false;
			} else if (isSeparator && lastCommitAppendedSpace) {
				
				if(currentLang != 1)
					deleteSpace = true;
				else {
					String f = t.trim();
					if(f.length() == 1 && frenchSeparators.contains(f))
						deleteSpace = false;
					else
						deleteSpace = true;
				}
				
				if (!t.endsWith(" "))
					appendSpace = true;				
			} else if(isSeparator && insertSpaceAfterSeparator) {
				if(!(insertPeriod && t.equals(". ")))
						appendSpace = true;
				lastCommitAppendedSpace = true;
			}
			else if (insertSpaceAfterSmiley && isSmiley(t)) {
				appendSpace = true;
				lastCommitAppendedSpace = true;
			} else
				lastCommitAppendedSpace = false;

			if (voiceInserted) {
				voiceInserted = false;

				if (t.equals(" "))
					return;
			}
		}
		
		//log("appendspace=" + appendSpace);
		
		connection.beginBatchEdit();

		if (composing && deleteSpace) {
			connection.setComposingText("", 1);
		}

		composing = false;		
		
		if (deleteSpace) {
			deleteLastIfSpace();
		}

		lastCommit = text;		

		if (insertPeriod && t.endsWith(" "))
			lastSpaceTime = SystemClock.uptimeMillis();
		else
			lastSpaceTime = 0;
		
		if(tripleComma > 0 && t.trim().endsWith(",")) {
			if(commaCount == 0 || (SystemClock.uptimeMillis() - lastCommaTime) < 1000) {
				commaCount++;
				lastCommaTime = SystemClock.uptimeMillis();
			}
			else {
				lastCommaTime = 0;
				commaCount = 0;
			} 
		}
		else {
			lastCommaTime = 0;
			commaCount = 0;
		}
		
		boolean forceCap = false;
		String toCommit = text.toString();
		
		if (toCommit.length() > 0 && separators.indexOf(toCommit.charAt(toCommit.length() - 1)) >= 0) {
			forceCap = true;
		}
		
		int cursorPos = 1;

		if (appendSpace && !appendPeriod) {
			
			CharSequence next = getTextAfterCursor(1);
			if(next != null && next.length() == 1 && next.charAt(0) == ' ') {
				cursorPos++;
			}
			else {
				toCommit = toCommit + " ";
				lastCommit = " ";
				lastCommitAppendedSpace = true;
				lastSpaceTime = android.os.SystemClock.uptimeMillis();
			}
		}

		if (appendPeriod) {
			String s = ". ";
			
			toCommit = toCommit + s;

			// log("commitText:appendPeriod '" + s + "'");
			lastCommit = s;
			lastCommitAppendedSpace = false;
		}
		
		int len = toCommit == null ? 0 : toCommit.length();		
		
		lastCommitWasEmpty = len == 0;
		
		lastSelStart += len;
		lastSelEnd += len;
		
		@SuppressWarnings("unused")
		boolean res = connection.commitText(toCommit, cursorPos);
		
		//log("commitText '" + toCommit + "' " + forceCap + " " + res);
		//logEditorInfo(service.getCurrentInputEditorInfo());
		
		if(forceCap && !noAutoCap) {
			forceAutoCapCheck();
		}
		
		connection.endBatchEdit();
	}

	public static void onFinishInput() {
		
		// log("onFinishInput:" + lastCommitAppendedSpace);

		if (!lastCommitAppendedSpace)
			return;

		deleteLastIfSpace();
	}

	public static boolean deleteLastIfSpace() {

		if (service == null) {
			log("deleteLastIfSpace: service is null");
			return false;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("deleteLastIfSpace: connection is null");
			return false;
		}

		CharSequence prevSeq = connection.getTextBeforeCursor(1, 0);

		if (prevSeq == null)
			return false;
		String prev = prevSeq.toString();

		if (prev == null)
			return false;

		if (prev.equals(" ")) {
			connection.deleteSurroundingText(1, 0);
			return true;
			// log("deleteLastIfSpace:" + true + " " + prev);
		}
		
		return false;
		// else
		// log("deleteLastIfSpace:" + false + " " + prev);
	}
	
	public static void moveAfterWord() {
		
		if (service == null) {
			log("moveAfterWord: service is null");
			return;
		}
		
		InputConnection connection = service.getCurrentInputConnection();
		
		if (connection == null) {
			log("moveAfterWord: connection is null");
			return;
		}
		
		
		if(composing) {
			
			try {
				finishComposingText(false);
				Object dataO = service.getClass().getField("mData").get(service);
				Object imO = dataO.getClass().getField("mCurrIM").get(dataO);
				imO.getClass().getMethod("finishInput", (Class[])null).invoke(imO, (Object[])null);
			}
			catch (Exception ex) {
				log("clear xt9 fail: " + ex.toString());
			}
		}
		
		CharSequence nextSeq = connection.getTextAfterCursor(1000, 0);
		
		if (nextSeq == null)
			return;
		char[] cs = nextSeq.toString().toCharArray();

		if (cs == null || cs.length < 1)
			return;
		int cnt = 0;
		boolean letterOrDigitFound = false; 
		for(int i = 0; i < cs.length; i++) {
			cnt++;
			letterOrDigitFound |= Character.isLetterOrDigit(cs[i]);
			if(cs[i] == ' ' && letterOrDigitFound)
				break;
		}
		
		if(cnt > 0) {
			connection.beginBatchEdit();
			connection.deleteSurroundingText(0, cnt);
			connection.commitText(nextSeq.subSequence(0, cnt), 1);
			connection.endBatchEdit();
			forceAutoCapCheck();
		}
	}
	
	public static void moveBeforeWord() {
		
		if (service == null) {
			log("moveBeforeWord: service is null");
			return;
		}
		
		InputConnection connection = service.getCurrentInputConnection();
		
		if (connection == null) {
			log("moveBeforeWord: connection is null");
			return;
		}
		
		
		if(composing) {
			
			try {
				finishComposingText(false);
				Object dataO = service.getClass().getField("mData").get(service);
				Object imO = dataO.getClass().getField("mCurrIM").get(dataO);
				imO.getClass().getMethod("finishInput", (Class[])null).invoke(imO, (Object[])null);
			}
			catch (Exception ex) {
				log("clear xt9 fail: " + ex.toString());
			}
		}
		
		CharSequence prevSeq = connection.getTextBeforeCursor(1000, 0);
		
		if (prevSeq == null)
			return;
		char[] cs = prevSeq.toString().toCharArray();

		int cnt = 0;
		boolean letterOrDigitFound = false;
		boolean nonSpaceDeleted = false;
		for(int i = cs.length - 1; i >= 0; i--) {			
			if(!Character.isLetterOrDigit(cs[i])) {
				if(letterOrDigitFound)
					break;
				
				if(cs[i] == ' ' && nonSpaceDeleted)
					break;
			}
			else
				letterOrDigitFound = true;
			
			nonSpaceDeleted = cs[i] != ' '; 
			
			cnt++;
		}		
		if(cnt > 0) {
			connection.beginBatchEdit();
			connection.deleteSurroundingText(cnt, 0);
			connection.commitText(prevSeq.subSequence(cs.length - cnt, cs.length), -1);
			connection.endBatchEdit();
			forceAutoCapCheck();
		}
	}
	
	public static void deleteLastWord() {

		if (service == null) {
			log("deleteLastWord: service is null");
			return;
		}
		
		voiceInserted = false;
		
		if(composing) {
			
			try {
				Object dataO = service.getClass().getField("mData").get(service);
				Object imO = dataO.getClass().getField("mCurrIM").get(dataO);
				imO.getClass().getMethod("finishInput", (Class[])null).invoke(imO, (Object[])null);
				setComposingText("", 1);
			}
			catch (Exception ex) {
				log("clear xt9 fail: " + ex.toString());
			}
		}
		else {

			InputConnection connection = service.getCurrentInputConnection();
	
			if (connection == null) {
				log("deleteLastWord: connection is null");
				return;
			}
			
			CharSequence prevSeq = connection.getTextBeforeCursor(100, 0);
	
			if (prevSeq == null)
				return;
			
			char[] cs = prevSeq.toString().toCharArray();
	
			if (cs == null || cs.length < 1)
				return;
	
			int cnt = 0;
			boolean letterOrDigitFound = false;
			boolean nonSpaceDeleted = false;
			for(int i = cs.length - 1; i >= 0; i--) {			
				if(!Character.isLetterOrDigit(cs[i])) {
					if(letterOrDigitFound)
						break;
					
					if(cs[i] == ' ' && nonSpaceDeleted)
						break;
				}
				else
					letterOrDigitFound = true;
				
				nonSpaceDeleted = cs[i] != ' '; 
				
				cnt++;
			}
			
			if (cnt > 0)
				connection.deleteSurroundingText(cnt, 0);
		}
			
		forceAutoCapCheck();
	}
	
	public static void deleteLastSentence() {

		if (service == null) {
			log("deleteLastSentence: service is null");
			return;
		}
		
		voiceInserted = false;
		
		if(composing) {
			
			try {
				Object dataO = service.getClass().getField("mData").get(service);
				Object imO = dataO.getClass().getField("mCurrIM").get(dataO);
				imO.getClass().getMethod("finishInput", (Class[])null).invoke(imO, (Object[])null);
				setComposingText("", 1);
			}
			catch (Exception ex) {
				log("clear xt9 fail: " + ex.toString());
			}
		}
		

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("deleteLastSentence: connection is null");
			return;
		}
		
		CharSequence prevSeq = connection.getTextBeforeCursor(1000, 0);

		if (prevSeq == null)
			return;
		
		char[] cs = prevSeq.toString().toCharArray();

		if (cs == null || cs.length < 1)
			return;
		
		String breakers = separators;

		int cnt = 0;
		boolean letterOrDigitDeleted = false;
		for(int i = cs.length - 1; i >= 0; i--) {			
			
			if((cs[i] == '\n' || breakers.indexOf(cs[i]) > -1) && letterOrDigitDeleted) {
				if(i < cs.length - 1 && cs[i + 1] == ' ')
					cnt--;
				break;
			}
			
			letterOrDigitDeleted |= Character.isLetterOrDigit(cs[i]); 
			
			cnt++;
		}
		
		if (cnt > 0) {
			connection.deleteSurroundingText(cnt, 0);			
		}		
			
		forceAutoCapCheck();
	}
	
	public static void deleteCommas(int commaCount) {

		if (service == null) {
			log("deleteCommas: service is null");
			return;
		}
		
		
		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("deleteCommas: connection is null");
			return;
		}
		
		CharSequence prevSeq = connection.getTextBeforeCursor(6, 0);

		if (prevSeq == null)
			return;
		
		char[] cs = prevSeq.toString().toCharArray();

		if (cs == null || cs.length < 1)
			return;
	
		int cnt = 0;
		int found = 0;
		for(int i = cs.length - 1; i >= 0; i--) {			
			
			if(cs[i] != ' ' && cs[i] != ',')
				break;
						
			cnt++;
			
			if(cs[i] == ',') {
				found++;
			}
			
			if(found >= commaCount)
				break;
		}
		
		if (cnt > 0) {
			connection.deleteSurroundingText(cnt, 0);
		}
	}
	
	public static boolean isWebEdit() {
		return ((inputType & InputType.TYPE_MASK_CLASS) == InputType.TYPE_CLASS_TEXT) &&
		((inputType & InputType.TYPE_MASK_VARIATION) == InputType.TYPE_TEXT_VARIATION_WEB_EDIT_TEXT);
	}
	
	public static void forceAutoCapCheck() {
		try {			
			Class<?> c = Class.forName("com.htc.android.htcime.HTCIMMData");
			Field f = c.getField("mForceAutoCapCheck");
			f.setBoolean(null, true);
			
			if ( isWebEdit()) {
				
				Method m = sipObj.getClass().getMethod("onCursorChanged", (Class[])null);
				m.invoke(sipObj, (Object[])null);
			}
					
		}
		catch(Exception ex) {
			log(ex.toString());
		}
	}
	
	public static void setIMECapMode(int mode, boolean force) {
		try {
			
			Method m = sipObj.getClass().getMethod("setIMECapMode", new Class[] {int.class, boolean.class});
			m.invoke(sipObj, new Object[] {mode, force});	
			
			Class<?> c = Class.forName("com.htc.android.htcime.HTCIMMData");
			Field f = c.getField("mForceAutoCapCheck");
			f.setBoolean(null, true);
		}
		catch(Exception ex) {
			log(ex.toString());
		}
	}

	public static int getCursorCapsMode(int reqModes) {
		
		//logStackTrace();

		if (service == null) {
			log("getCursorCapsMode: service is null");
			return 0;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("getCursorCapsMode: connection is null");
			return 0;
		}
		
		int res = connection.getCursorCapsMode(reqModes);
		
		//log("getCursorCapsMode(" + reqModes + "):" + res);

		return res;
	}

	public static boolean deleteSurroundingText(int leftLength, int rightLength) {
		// log("deleteSurroundingText:" + leftLength + " " + rightLength);

		if (service == null) {
			log("deleteSurroundingText: service is null");
			return false;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("deleteSurroundingText: connection is null");
			return false;
		}

		return connection.deleteSurroundingText(leftLength, rightLength);
	}

	public static boolean finishComposingText() {
		//log("finishComposingText");
		voiceInserted = true;
		return finishComposingText(false);
	}

	public static boolean finishComposingText(boolean isVoice) {

		composing = false;

		//log("finishComposingText " + isVoice);

		if (service == null) {
			log("finishComposingText: service is null");
			return false;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("finishComposingText: connection is null");
			return false;
		}

		return connection.finishComposingText();
	}

	public static CharSequence getTextBeforeCursor(int n, int m) {
		return getTextBeforeCursor(n);
	}

	public static CharSequence getTextBeforeCursor(int n) {

		CharSequence res = "";
		if (service == null) {
			log("getTextBeforeCursor: service is null");
			return res;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("getTextBeforeCursor: connection is null");
			return res;
		}

		try {
			res = connection.getTextBeforeCursor(n, 0);

			// log("getTextBeforeCursor:'" + res + "'" + n);
		} catch (Exception ex) {
			log("getTextBeforeCursor exception:" + ex.toString());
		}

		return res;
	}

	public static CharSequence getTextAfterCursor(int n) {

		CharSequence res = "";
		if (service == null) {
			log("getTextAfterCursor: service is null");
			return res;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("getTextAfterCursor: connection is null");
			return res;
		}

		try {
			res = connection.getTextAfterCursor(n, 0);

			// log("getTextAfterCursor:'" + res + "'" + n);
		} catch (Exception ex) {
			log("getTextAfterCursor exception:" + ex.toString());
		}

		return res;
	}

	public static boolean sendKeyEvent(KeyEvent e) {
		//log("sendKeyEvent:" + e);

		composing = false;
		lastCommitAppendedSpace = false;
		lastCommit = "";
		lastSpaceTime = 0;
		lastCommaTime = 0;
		commaCount = 0;

		if (service == null) {
			log("sendKeyEvent: service is null");
			return false;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("sendKeyEvent: connection is null");
			return false;
		}
		
		return connection.sendKeyEvent(e);
	}

	public static void sendSimKeyEventDown(int code) {

		//log("sendSimKeyEventDown:" + code);

		composing = false;
		lastCommitAppendedSpace = false;
		lastCommit = "";
		lastSpaceTime = 0;
		lastCommaTime = 0;
		commaCount = 0;

		KeyEvent e = new KeyEvent(SystemClock.uptimeMillis(), SystemClock
				.uptimeMillis(), KeyEvent.ACTION_DOWN, code, 0, 0, 0, 0,
				KeyEvent.FLAG_KEEP_TOUCH_MODE | KeyEvent.FLAG_SOFT_KEYBOARD);

		if(code == 67) {
			lastSelStart = Math.max(lastSelStart - 1, 0);
			lastSelEnd = lastSelStart;
		}
		
		sendKeyEvent(e);
	}

	public static void sendSimKeyEvent(int code) {

		//log("sendSimKeyEvent:" + code);
		//logStackTrace();

		if (service == null) {
			log("sendSimKeyEvent: service is null");
			composing = false;
			lastCommitAppendedSpace = false;
			lastCommit = "";
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("sendSimKeyEvent: connection is null");
			composing = false;
			lastCommitAppendedSpace = false;
			lastCommit = "";
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
			return;
		}

		try {
			if (code == 0x42) {

				if (insertSpace && lastCommitAppendedSpace)
					deleteLastIfSpace();

				if (shiftEnter) {
					// log("sendSimKeyEvent:shiftEnter");
					KeyEvent e = new KeyEvent(SystemClock.uptimeMillis(),
							SystemClock.uptimeMillis(), KeyEvent.ACTION_DOWN,
							code, 0, KeyEvent.META_SHIFT_ON, 0, 0,
							KeyEvent.FLAG_KEEP_TOUCH_MODE
									| KeyEvent.FLAG_SOFT_KEYBOARD);
					sendKeyEvent(e);
					return;
				} else {
					if (forceAction) {
						 //log("sendSimKeyEvent:forceaction");
						service.sendDefaultEditorAction(false);
						return;
					}

					if (service.sendDefaultEditorAction(true)) {
						//log("sendSimKeyEvent:sendDefaultEditorAction");
						return;
					}
				}
			}
			// log("sendSimKeyEvent:sendDownUpKeyEvents");
			if(code == 67) {
				lastSelStart = Math.max(lastSelStart - 1, 0);
				lastSelEnd = lastSelStart;
			}
			
			service.sendDownUpKeyEvents(code);
		} finally {
			composing = false;
			lastCommitAppendedSpace = false;
			lastCommit = "";
			lastSpaceTime = 0;
			lastCommaTime = 0;
			commaCount = 0;
		}
	}

	public static boolean commitCompletion(CompletionInfo info) {

		composing = false;
		lastCommitAppendedSpace = false;
		lastCommit = "";
		lastSpaceTime = 0;
		lastCommaTime = 0;
		commaCount = 0;
		//log("commitCompletion:" + info.getText() + " " + (info.getLabel() == null ? "null" : info.getLabel()));
		//logStackTrace();

		if (service == null) {
			log("commitCompletion: service is null");
			return false;
		}

		InputConnection connection = service.getCurrentInputConnection();

		if (connection == null) {
			log("commitCompletion: connection is null");
			return false;
		}

		return connection.commitCompletion(info);
	}

	/* Hard keyboard hacks */

	
	public static boolean isInputViewShown() {
		
		if (service == null)			
			return false;
		
		return service.isInputViewShown();
	}
	
	private static void cursorLeft() {
		int sel = Math.max(0, lastSelStart - 1);
		setEditSelection(sel, sel);
		forceAutoCapCheck();
	}
	
	private static void cursorRight() {
		int sel = lastSelStart + 1;
		setEditSelection(sel, sel);
		forceAutoCapCheck();
	}
	
	private static void clearXT9() {
		
		if(composing) {
			try {
				finishComposingText(false);
				Object dataO = service.getClass().getField("mData").get(service);
				Object imO = dataO.getClass().getField("mCurrIM").get(dataO);
				imO.getClass().getMethod("finishInput", (Class[])null).invoke(imO, (Object[])null);
			}
			catch (Exception ex) {
				log("clear xt9 fail: " + ex.toString());
			}
		}
	}	
	
	public static boolean backHandled;
	public static boolean downHandled;
	
	public static void setBackHandled() {
		backHandled = true;
	}
	
	public static boolean hwKeyDown(int code, KeyEvent e) {
		backHandled = false;
		downHandled = false;
		//log("hwKeyDown " + code);
		if(!hasVolumeAction || !isInputViewShown() || service == null)
			return false;
		
		
		switch(code) {
			case KeyEvent.KEYCODE_VOLUME_DOWN:
				
				if(volumeKeys.equals("move")) {
					if(lastO == Configuration.ORIENTATION_PORTRAIT)
						cursorLeft();
					else 
						cursorRight();
				
					downHandled = true;
				}
				else if(volumeKeys.equals("arrow")) {
					
					KeyEvent e2 = new KeyEvent(e.getDownTime(), e.getEventTime(), e.getAction(),
							KeyEvent.KEYCODE_DPAD_DOWN, e.getRepeatCount(), e.getMetaState());
					e2 = KeyEvent.changeFlags(e2, e.getFlags());
					
					if(e.getRepeatCount() == 0)
						clearXT9();
					
					sendKeyEvent(e2);
					
					downHandled = true;
				}
				else if(volumeKeys.equals("lang")) {
					downHandled = true;
					if(e.getRepeatCount() == 0)
						changeLanguage(PrefsLang.getPreviousLanguage(service));
				}
				break;
				
			case KeyEvent.KEYCODE_VOLUME_UP:
				if(volumeKeys.equals("move")) {
					if(lastO == Configuration.ORIENTATION_PORTRAIT)
						cursorRight();
					else 
						cursorLeft();
					
					downHandled = true;
				}
				else if(volumeKeys.equals("arrow")) {					
					KeyEvent e2 = new KeyEvent(e.getDownTime(), e.getEventTime(), e.getAction(),
							KeyEvent.KEYCODE_DPAD_UP, e.getRepeatCount(), e.getMetaState());
					e2 = KeyEvent.changeFlags(e2, e.getFlags());
					
					if(e.getRepeatCount() == 0)
						clearXT9();
					
					sendKeyEvent(e2);
					downHandled = true;
				}
				else if(volumeKeys.equals("lang")) {
					downHandled = true;
					if(e.getRepeatCount() == 0)
						changeLanguage(PrefsLang.getNextLanguage(service));
				}
				break;
		}
		
		return downHandled;
	}
	
	public static boolean hwKeyUp(int code, KeyEvent e) {
		
		//log("hwKeyUp " + code);	
		if(!downHandled)
			return false;
		
		
		switch(code) {
		case KeyEvent.KEYCODE_VOLUME_DOWN:
			
			if(volumeKeys.equals("arrow")) {
				
				KeyEvent e2 = new KeyEvent(e.getDownTime(), e.getEventTime(), e.getAction(),
						KeyEvent.KEYCODE_DPAD_DOWN, e.getRepeatCount(), e.getMetaState());
				e2 = KeyEvent.changeFlags(e2, e.getFlags());
				
				sendKeyEvent(e2);
			}
			break;
			
		case KeyEvent.KEYCODE_VOLUME_UP:
			if(volumeKeys.equals("arrow")) {					
				KeyEvent e2 = new KeyEvent(e.getDownTime(), e.getEventTime(), e.getAction(),
						KeyEvent.KEYCODE_DPAD_UP, e.getRepeatCount(), e.getMetaState());
				e2 = KeyEvent.changeFlags(e2, e.getFlags());
				
				sendKeyEvent(e2);
			}
			break;
		}
		
		return true;
	}

	public static Object hwKBObj;

	public static void setHWKBObj(Object obj) {
		hwKBObj = obj;
	}

	@SuppressWarnings("unchecked")
	public static void hwKBStartInput() {

		try {
			for (Method m : hwKBObj.getClass().getMethods()) {
				if (m.getName().equals("getKeyboard")) {
					Object kb = m.invoke(hwKBObj, (Object[]) null);

					for (Method m2 : kb.getClass().getMethods()) {
						if (m2.getName().equals("getKeys")) {

							List keys = (List) m2.invoke(kb, (Object[]) null);
							setHWKeys(keys);

							break;
						}
					}

					break;
				}
			}
		} catch (Exception e) {
			log("hwKBStartInput fail: " + e.toString());
		}
	}

	public static ArrayList<Integer> hwKeys;

	@SuppressWarnings("unchecked")
	public static void setHWKeys(List keys) {

		hwKeys = new ArrayList<Integer>();
		for (int i = 0; i < keys.size(); i++) {
			Object key = keys.get(i);

			int[] codes = getCodes(key);

			if (codes != null && codes.length > 0) {
				hwKeys.add(new Integer(codes[0]));
			} else
				hwKeys.add(new Integer(0));
		}

		// log("hwKeys: " + Arrays.toString(hwKeys.toArray()));
	}

	public static int getHWCharKeyIndex(int code) {
		int result = -1;

		for (int i = 0; i < hwKeys.size(); i++) {
			if (hwKeys.get(i).intValue() == code) {
				result = i;
				break;
			}
		}

		// log("getHWCharKeyIndex: " + code + " -> " + result);

		return result;
	}

	public static int getHWSpecialKeyIndex(int code) {
		int result = -1;
		int realCode = -1000;
		switch (code) {
		case 55:
			realCode = 44;
			break; // comma
		case 56:
			realCode = 46;
			break; // period
		case 59:
			realCode = -1;
			break; // shift left
		case 60:
			realCode = -1;
			break; // shift shift right
		case 66:
			realCode = 10;
			break; // enter
		case 67:
			realCode = -5;
			break; // backspace

		}

		for (int i = 0; i < hwKeys.size(); i++) {
			if (hwKeys.get(i).intValue() == realCode) {
				result = i;
				break;
			}
		}

		// log("getHWSpecialKeyIndex: " + code + " -> " + realCode + " -> " +
		// result);

		return result;
	}

	/* Keyboard layout hacks. These are REALLY messy. Beware. */
	
	public static int getPortQwertySym(int def) {

		if(altSymb)
			return 5;
		
		return def;
	}
	
	public static int checkAltSymb(int def) {
		
		if(altSymb && def == 3)
			return 5;
		
		return def;
	}
	
	public static int getPhonePauseCode() {
		
		// Send p on Sense and , on vanilla
		try {
			Class<?> c = Class.forName("com.htc.widget.HtcListView"); // Only on Sense ROMs
			if(c !=  null)
				return 0xf000070;
		}
		catch (Exception e) {
		}
		
		return 0xf00002c;
	}
	
	/* .com key hack */
	
	public static void updateDotComKey(Object key) {
		if(!customDomainsToggle)
			return;
		
		try {
			Field f = key.getClass().getField("popupCharacters");
			String currentString = f.get(key).toString();
			int zeroIdx = -1;
			if(currentString.contains("0")) {
				String[] current = currentString.split("\\s+");
				for (int i = 0; i < current.length; i++) {
					if(current[i].trim().equals("0")) {
						zeroIdx = i;
					}
				}
			}
			
			f.set(key, getPopupDomains(zeroIdx));
						
		} catch (Exception e) {
		}
	}
	
	public static int getPhoneWaitCode() {
		
		// Send p on Sense and , on vanilla
		try {
			Class<?> c = Class.forName("com.htc.widget.HtcListView"); // Only on Sense ROMs
			if(c !=  null)
				return 0xf000077;
		}
		catch (Exception e) {
		}
		
		return 0xf00003b;
	}

	public static boolean loadKBIsLandscape = false;
	public static boolean loadKBIsQwertyPortrait = false;
	public static void startLoadKeyboard(int resId) {
		loadKBIsLandscape = false;
		loadKBIsQwertyPortrait = false;		
		try {
			Class<?> c = Class.forName("com.htc.android.htcime.R$xml");
			
			if(	resId == c.getField("qwerty").getInt(null) ||
					resId == c.getField("qwerty_de").getInt(null) ||
					resId == c.getField("qwerty_engre").getInt(null) ||
					resId == c.getField("qwerty_enrus").getInt(null) ||
					resId == c.getField("qwerty_fr").getInt(null) ||
					resId == c.getField("qwerty_gre").getInt(null)) {
					
					loadKBIsQwertyPortrait = true;	
			}
			else if(resId == c.getField("land_phone_sip").getInt(null) ||
				resId == c.getField("land_qwe_symbol_sip").getInt(null) ||
				resId == c.getField("land_qwerty").getInt(null) ||
				resId == c.getField("land_qwerty_de").getInt(null) ||
				resId == c.getField("land_qwerty_engre").getInt(null) ||
				resId == c.getField("land_qwerty_enrus").getInt(null) ||
				resId == c.getField("land_qwerty_fr").getInt(null) ||
				resId == c.getField("land_qwerty_gre").getInt(null) ||
				resId == c.getField("land_qwerty_rus").getInt(null)) {
				
				loadKBIsLandscape = true;
			}
		} catch (Exception ex) {
			log("startLoadKeyboard: " + ex.toString());
		}
	}
	
	/* Scale landscape keyboard width (Droid) */
	public static float landscapeDownScale = 1f;
	public static boolean landscapeScaled = false;
	public static int qwertyWidthAdjust = -1;
	
	public static int getRowStart(int w) {
		if(!loadKBIsQwertyPortrait)
			return w;
		
		int res = w - getQwertyWidthAdjust() / 2;
		return res;
	}
	
	public static int getQwertyWidthAdjust() {
		if(qwertyWidthAdjust < 0) {
			if(prefs == null && service != null) {
				prefs = PreferenceManager.getDefaultSharedPreferences(service);
			}
			
			if(prefs != null) {
				qwertyWidthAdjust = Integer.valueOf(prefs.getString("qwertyWidthAdjust", "0"));
			}
			qwertyWidthAdjust = Math.max(qwertyWidthAdjust, 0);
		}
		
		return qwertyWidthAdjust;
	}
	public static int modifyKeyWidth(int w) {		
		int res = w;
		
		if(loadKBIsLandscape && (lastScreenWidth > 800 || lastScreenHeight > 800)) {			
			float factor = Math.max((float)lastScreenWidth , (float)lastScreenHeight) / 800f;			
			res = (int) Math.round((float)w * factor);
			landscapeScaled = true;
			landscapeDownScale = 1.0f / factor;
		}
		else if (loadKBIsQwertyPortrait) {
			res = w - getQwertyWidthAdjust();
		}
		return res;		
	}
	
	public static int modifyKeyboardKeyWidth(int w) {		
		int res = w;
		
		if(loadKBIsLandscape && (lastScreenWidth > 800 || lastScreenHeight > 800)) {			
			float factor = Math.max((float)lastScreenWidth , (float)lastScreenHeight) / 800f;			
			res = (int) Math.round((float)w * factor);
			landscapeScaled = true;
			landscapeDownScale = 1.0f / factor;
		}
		else if (loadKBIsQwertyPortrait) {
			res = w - getQwertyWidthAdjust();
		}
		return res;		
	}
	
	public static int modifyHGap(int w) {		
		
		int res = w;
		
		if(loadKBIsLandscape && (lastScreenWidth > 800 || lastScreenHeight > 800)) {			
			float factor = Math.max((float)lastScreenWidth , (float)lastScreenHeight) / 800f;			
			res = (int) Math.round((float)w * factor);
			landscapeScaled = true;
			landscapeDownScale = 1.0f / factor;
		}
		else if (loadKBIsQwertyPortrait) {			
			res = w + getQwertyWidthAdjust();
		}
		return res;
	}
	
	public static int modifyKeyboardHGap(int w) {		
		int res = w;
		
		if(loadKBIsLandscape && (lastScreenWidth > 800 || lastScreenHeight > 800)) {			
			float factor = Math.max((float)lastScreenWidth , (float)lastScreenHeight) / 800f;			
			res = (int) Math.round((float)w * factor);
			landscapeScaled = true;
			landscapeDownScale = 1.0f / factor;
		}
		else if (loadKBIsQwertyPortrait) {
			res = w + getQwertyWidthAdjust();			
		}
		return res;		
	}
	
	public static int downScaleTouchPoint(int x) {
		if(!landscapeScaled)			
			return x;
		
		return (int)(landscapeDownScale * x);
	}
	
	public static int getPaddingLeft(int accType, LinearLayout l) {

		int res = l.getPaddingLeft();
		if (accType == 1 && lastO == Configuration.ORIENTATION_PORTRAIT)
			res = res / 3;
		accentWidth += res;
		return res;
	}

	public static int getPaddingRight(int accType, LinearLayout l) {

		int res = l.getPaddingLeft();
		if (accType == 1 && lastO == Configuration.ORIENTATION_PORTRAIT)
			res = res / 3;
		accentWidth += res;
		return res;
	}

	public static int accentWidth;

	public static void resetAccentWidth() {
		accentWidth = 0;
	}

	static Paint paint = new Paint();

	public static void fixTextView(TextView tv) {

		LayoutParams lp = tv.getLayoutParams();

		CharSequence cs = tv.getText();
		
		if (cs == null || cs.length() < 2) {
			accentWidth += lp.width;
			return;
		}
		
		int min = 39;

		if (cs.charAt(0) == '.') {
			min = lp.width;			
		}

		paint.setTextSize(tv.getTextSize());
		paint.setTextScaleX(tv.getTextScaleX());
		paint.setTypeface(tv.getTypeface());

		float w = paint.measureText(cs.toString());

		WindowManager winMgr = (WindowManager) service
				.getSystemService(Context.WINDOW_SERVICE);
		DisplayMetrics metrics = new DisplayMetrics();
		winMgr.getDefaultDisplay().getMetrics(metrics);
		
		boolean hires = metrics.widthPixels >= 800 || metrics.heightPixels >= 800;
		float xdpi = hires ? 245f : 160f;
		w = (xdpi * w) / 160f;		
		int ceil = (int) Math.ceil(w);
		ceil = Math.max(ceil, min);
		// log("fixTextView w" + w + " " + ceil + " " + cs);
		lp.width = ceil;
		tv.setLayoutParams(lp);
		accentWidth += lp.width;
	}

	public static int getSmileyCode() {

		int res = 0x7110000;

		if (firstSmileyIdx > 0) {
			res |= firstSmileyIdx;			
		}

		return res;
	}
	
	public static int getDomainKeyCode() {

		int res = 0x7110000;

		if (keyDomainIdx > 0) {
			res |= keyDomainIdx;			
		}

		return res;
	}

	// Add smileys and stuff
	public static String[] smileys = new String[] { ":)", ":-)", ";-)", ":-D",
			":-P", "B-)", ":-(", ":-[", ":'(", ":-/", ":-\\", ":O", ";)", ":(", ":'(",
			":o", ":P", ":$", ":/", ":S", ":-$" };
	public static String[] customSmileys = null;
		
	public static int firstSmileyIdx = -1;
	public static int keyDomainIdx = -1;

	public static String[] setmSpecTerms(String[] ss) {
		
		if (prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);

		ArrayList<String> l = new ArrayList<String>();
		for (String s : ss) {
			l.add(s);
		}

		firstSmileyIdx = l.size();
		for (String s : getSmileys())
			l.add(s);
		
		keyDomainIdx = l.size();
		l.add(getKeyDomain());
		
		for (String s : getPopupDomains())
			l.add(s);		

		return l.toArray(ss);
	}
	
	public static String[] getSmileys() {
		
		String[] aSmileys = { ":-)", ";-)", ":-D", ":-P", "B-)", ":-(", ":-[", ":'(", ":-\\", ":O" };
		String[] nSmileys = new String[] { ":)", ";)", ":(", ":'(", ":o", ":P", ":$", ":/", ":S" };
		
		if (service != null) {
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
			
			androidSmileys = prefs.getBoolean("androidSmileys", androidSmileys);
			boolean customSmileysToggle = prefs.getBoolean("customSmileysToggle", false);
			customSmileys = prefs.getString("customSmileys", "").split("\\s+");
			
			if(!customSmileysToggle || customSmileys == null || customSmileys.length < 2) {
				if(androidSmileys)
					return aSmileys;
				else
					return nSmileys;
			}
			else 
				return customSmileys;
		}
		else {
			return aSmileys;
		}		
	}
	
	public static String getKeyDomain() {
		
		String keyDomain = ".com";
		if(prefs == null) {
			if (service != null) {
				prefs = PreferenceManager.getDefaultSharedPreferences(service);
			}
		}
		
		if(prefs != null) {		
			keyDomain = prefs.getString("keyDomain", keyDomain);
		}
		return keyDomain.trim();
	}
	
	public static String getPopupDomains(int zeroIdx) {
		
		String result = ".net .com .org .edu";
		if(prefs == null) {
			if (service != null) {
				prefs = PreferenceManager.getDefaultSharedPreferences(service);
			}
		}
		
		if(prefs != null) {
			String configString = prefs.getString("popupDomains", result);
			String[] ds = configString.split("\\s+");
			
			StringBuilder sb = new StringBuilder();
			for(int i = 0; i < ds.length; i++) {
				if(zeroIdx == i) {
					sb.append("0");
					sb.append(" ");
				}
				
				sb.append(ds[i]);
				sb.append(" ");
			}
			
			result = sb.toString().trim();
		}
		
		return result;
	}
	
	public static String[] getPopupDomains() {
		
		String[] result = {".net", ".com", ".org", ".edu"};
		if(prefs == null) {
			if (service != null) {
				prefs = PreferenceManager.getDefaultSharedPreferences(service);
			}
		}
		
		if(prefs != null) {
			String configString = prefs.getString("popupDomains", ".net .com .org .edu");
			result = configString.split("\\s+");
		}
		
		return result;
	}

	public static boolean isSmiley(CharSequence c) {
		
		if(c.length() < 2)
			return false;
		
		String s = c.toString();
		
		if(customSmileys != null) {
			for (String sm : customSmileys) {
				if (sm.equals(s))
					return true;
			}
		}

		for (String sm : smileys) {
			if (sm.equals(s))
				return true;
		}
		
		return false;
	}
	
	public static void logKey(int i, Object key) {
		try {
		int[]codes = getCodes(key);
		 Object labelObj = key.getClass().getField("label").get(key);
		 String label = labelObj == null ? "null" :
		 labelObj.toString();

		 Object popupCharactersObj = key.getClass().getField("popupCharacters").get(key);
		 CharSequence popupCharacters = popupCharactersObj == null ?
		 "null" : (CharSequence)popupCharactersObj;
		 
		 
		 char[] cs = popupCharacters.toString().toCharArray();
		 int[] ps = new int[cs.length];
		 int j = 0;
		 for(char c : cs) {
			 ps[j] = (int)c;
			 j++;
		 }

		Field textField = key.getClass().getField("text");
		Object textObj = textField.get(key);
		String text = textObj == null ? "null" : textObj.toString();

		 float textScale =
		 key.getClass().getField("textScale").getFloat(key);
		 
		 log("key " + i + " label:" + label + " text:" + text +
					" popup:" + popupCharacters + " " + 
					//Arrays.toString(ps) +
					" s:" + textScale + " c:" +
					Arrays.toString(codes));
		}
		catch (Exception e) {
			log("key " + i + ": " + e.toString());
		}
	}
	
	static void swapFields(Object o1, Object o2, String fieldName) {
		
		try {
			
			Class<?> c = o1.getClass();
			Field f = c.getField(fieldName);
			Object v1 = f.get(o1);
			Object v2 = f.get(o2);
			
			f.set(o1, v2);
			f.set(o2, v1);
		}
		catch (Exception e) {
		}
	}
	
	
	public static void updateKeys() {
		if(sipObj == null || service == null)
			return;
		if(prefs == null)
			prefs = PreferenceManager.getDefaultSharedPreferences(service);
		boolean enabled = prefs.getBoolean("localizePopups", true);
		if(!enabled)
			return;
		
		String name = sipObj.getClass().getName();
		try {			
			
			if(currentLang == lastUpdatedLang && lastUpdatedKB.equals(name)) {
				return;
			}
			
			lastUpdatedLang = currentLang;
			lastUpdatedKB = name;
			
			if(name.equals("com.htc.android.htcime.ezsip.PortQwertySIPView") ||
			   name.equals("com.htc.android.htcime.ezsip.LandQwertySIPView")) {
				Object kbO = sipObj.getClass().getField("mKeyboard").get(sipObj);				
				Method m = kbO.getClass().getMethod("getKey", new Class[] {int.class});
				
				String popupChars;
				Object key;
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'a') });
				switch(currentLang) {
				case 1: popupChars = "1 à á â ã ä å æ ą"; break;
				case 2: popupChars = "! ä à á â ã å æ ą"; break;
				case 8: popupChars = "! æ å á ä à â ã ą"; break;
				case 9: popupChars = "! ä å æ à á â ã ą"; break;
				case 10: popupChars = "! å æ á ä à â ã ą"; break;
				case 13: popupChars = "! ą à á â ã ä å æ"; break;
				default: popupChars = "! à á â ã ä å æ ą"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);				
				
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'c') });
				switch(currentLang) {				
				case 13: popupChars = "' ć ç č"; break;
				default: popupChars = "' ç ć č"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'u') });
				switch(currentLang) {				
				case 2: popupChars = "ű ů û ú ù ü 7"; break;
				default: popupChars = "ű ů ü û ú ù 7"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'f') });
				switch(currentLang) {
				default: popupChars = "$ € £"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'e') });
				switch(currentLang) {				
				case 13: popupChars = "3 ę è é ê ë ě"; break;
				default: popupChars = "3 è é ê ë ę ě"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'l') });
				switch(currentLang) {				
				case 13: popupChars = "ľ ĺ ł /"; break;
				default: popupChars = "ľ ĺ ł /"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'n') });
				switch(currentLang) {				
				case 13: popupChars = "ň ñ ń -"; break;
				default: popupChars = "ň ń ñ -"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'o') });
				switch(currentLang) {
				case 2: popupChars = "ő ø œ õ ô ó ò ö 9"; break;
				case 8: popupChars = "ő œ õ ô ó ò ö ø 9"; break;
				case 9: popupChars = "ő œ õ ô ó ò ø ö 9"; break;
				case 10: popupChars = "ő œ õ ô ó ò ö ø 9"; break;
				case 13: popupChars = "ő ø œ ö õ ô ò ó 9"; break;
				default: popupChars = "ő ø œ ö õ ô ó ò 9"; break;
				}				
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'s') });
				switch(currentLang) {				
				case 13: popupChars = "@ ś ß ş š"; break;
				default: popupChars = "@ ß ś ş š"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'q') });
				switch(currentLang) {				
				case 1: popupChars = "!"; break;
				default: popupChars = "1"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'w') });
				switch(currentLang) {				
				case 1: popupChars = "_"; break;
				default: popupChars = "2"; break;
				}
				key.getClass().getField("popupCharacters").set(key, popupChars);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'y') });
				switch(currentLang) {				
				case 2: popupChars = "_ ý ÿ"; break;				
				default: popupChars = "6 ý ÿ"; break;
				}				
				key.getClass().getField("popupCharacters").set(key, popupChars);				
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'z') });
				switch(currentLang) {
				case 1: popupChars = "2 ź ż ž"; break;
				case 2: popupChars = "6 ź ż ž"; break;
				case 13: popupChars = "_ ż ź ž"; break;
				default: popupChars = "_ ź ż ž"; break;
				}				
				key.getClass().getField("popupCharacters").set(key, popupChars);				
							
			}
			else if(name.equals("com.htc.android.htcime.ezsip.Port12KeySIPView")) {
				Object kbO = sipObj.getClass().getField("mKeyboard").get(sipObj);				
				Method m = kbO.getClass().getMethod("getKey", new Class[] {int.class});
				
				String popupChars;
				int alignIndex;
				
				Object key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'a') });
				switch(currentLang) {
				case 8: popupChars = "æ c b a 2 A B C Æ"; alignIndex = 4; break;
				case 9: popupChars = "ä å c b a 2 A B C"; alignIndex = 5; break;
				case 10: popupChars = "æ c b a 2 A B C Æ"; alignIndex = 4; break;
				default: popupChars = "c b a 2 A B C"; alignIndex = 3; break;
				}
				
				key.getClass().getField("popupCharacters").set(key, popupChars);
				key.getClass().getField("alignIndex").setInt(key, alignIndex);
				
				key = m.invoke(kbO, new Object[] { Integer.valueOf((int)'m') });
				switch(currentLang) {
				case 8: popupChars = "ø o n m Ø O N M 6"; alignIndex = 8; break;
				case 9: popupChars = "ö o n m Ö O N M 6"; alignIndex = 8; break;
				case 10: popupChars = "ø o n m Ø O N M 6"; alignIndex = 8; break;
				default: popupChars = "o n m O N M 6"; alignIndex = 6; break;
				}
				
				key.getClass().getField("popupCharacters").set(key, popupChars);
				key.getClass().getField("alignIndex").setInt(key, alignIndex);
			}
		}
		catch (Exception e) {
			log("updateKeys: " + e.toString());
		}
	}

	@SuppressWarnings("unchecked")
	public static void modifyKeyLists(List keys, List groups, List splits, Object owner) {	
		
		lastUpdatedLang = -1;
		lastUpdatedKB = "";
		boolean swapSmileys = false;
		customDomainsToggle = false;
		String keyDomain = getKeyDomain();

		if (service != null) {
			prefs = PreferenceManager.getDefaultSharedPreferences(service);

			spaceHack = prefs.getBoolean("spaceHack", spaceHack);
			smileyHack = prefs.getBoolean("smileyHack", smileyHack);
			androidSmileys = prefs.getBoolean("androidSmileys", androidSmileys);
			swapSmileys = prefs.getBoolean("swapSmileys", swapSmileys);
			customDomainsToggle = prefs.getBoolean("customDomainsToggle", customDomainsToggle);
		}
		if (spaceHack || customDomainsToggle) {

			try {

				List s = new ArrayList();
				Object firstSplit = null;
				Object lastSplit = null;

				Object spaceIcon = null;
				Object spaceIconPreview = null;

				for (int i = 0; i < splits.size(); i++) {
					Object key = splits.get(i);

					if (hasCode(key, 0x20)) {
						int splitSet = key.getClass().getField("splitSet")
								.getInt(key);
						if (splitSet == 1) {
							
							spaceIcon = key.getClass().getField("icon")
									.get(key);
							spaceIconPreview = key.getClass().getField(
									"iconPreview").get(key);

							for (Field f : key.getClass().getFields()) {
								String name = f.getName();
								try {
									@SuppressWarnings("unused")
									String val;
									Object valO = f.get(key);
									if (valO == null)
										val = "null";
									else {
										if (name.equals("codes")) {
											val = Arrays
													.toString(getCodes(key));
										} else
											val = valO.toString();
									}

								} catch (Exception ex) {
									log("space key skipping field '"
											+ f.getName() + "':"
											+ ex.getMessage());
								}
							}
						}
					}
					
					if(customDomainsToggle && hasCode(key, -7)) {
						if(keyDomain.length() > 0) {
							key.getClass().getField("label").set(key, keyDomain);
						}
					}

					int splitSet = key.getClass().getField("splitSet").getInt(
							key);

					if (splitSet != 2)
						continue;

					s.add(key);
				}			
				

				if (spaceHack && s.size() == 3) {

					firstSplit = s.get(0);
					lastSplit = s.get(2);

					Class c = firstSplit.getClass();

					Field f = c.getField("label");

					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, null);

					f = c.getField("top_label");
					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, null);

					f = c.getField("codes");
					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, new int[] { -0x20 });

					f = c.getField("popupCharacters");
					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, null);

					f = c.getField("accentType");
					f.setInt(firstSplit, f.getInt(lastSplit));
					f.set(lastSplit, 0);

					f = c.getField("multiLine");
					f.setBoolean(firstSplit, f.getBoolean(lastSplit));
					f.setBoolean(lastSplit, false);

					f = c.getField("showPreview");
					f.setBoolean(firstSplit, f.getBoolean(lastSplit));
					f.setBoolean(lastSplit, true);

					f = c.getField("repeatable");
					f.setBoolean(firstSplit, f.getBoolean(lastSplit));
					f.setBoolean(lastSplit, false);

					f = c.getField("labelShiftY");
					f.setInt(firstSplit, f.getInt(lastSplit));

					f = c.getField("icon");
					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, spaceIcon);

					f = c.getField("iconPreview");
					f.set(firstSplit, f.get(lastSplit));
					f.set(lastSplit, spaceIconPreview);

					f = c.getField("mFeedBackBG");
					f.setInt(firstSplit, f.getInt(lastSplit));
					f.setInt(lastSplit, 0);

					for (Field f2 : lastSplit.getClass().getFields()) {
						String name = f2.getName();
						try {
							@SuppressWarnings("unused")
							String val;
							Object valO = f2.get(lastSplit);
							if (valO == null)
								val = "null";
							else {
								if (name.equals("codes")) {
									val = Arrays.toString(getCodes(lastSplit));
								} else
									val = valO.toString();
							}
						} catch (Exception ex) {
						}
					}
				}
			} catch (Exception e) {
				log("split ex: " + e.toString());
			}
		}
		try {
			Object settingsKey = null;
			Class<?> settingsKeyClass = null;
			// log("keys:" + keys.size());
			int smileyIndex = -1;
			int symbIndex = -1;
			for (int i = 0; i < keys.size(); i++) {
				Object key = keys.get(i);
				
				Field textField = key.getClass().getField("text");
				Object textObj = textField.get(key);
				String text = textObj == null ? "null" : textObj.toString();
				
				Field labelField = key.getClass().getField("label");
				Object labelObj = labelField.get(key);
				@SuppressWarnings("unused")
				String label = labelObj == null ? "null" : labelObj.toString();

				int[]codes = getCodes(key);
				
				//logKey(i, key);

				if (androidSmileys) {
					if (text.equals(":)")) {
						textField.set(key, ":-)");
					} else if (text.equals(";)")) {
						textField.set(key, ";-)");
					} else if (text.equals(":(")) {
						textField.set(key, ":-(");
					} else if (text.equals(":P")) {
						textField.set(key, ":-P");
					} else if (text.equals(":$")) {
						textField.set(key, ":-$");
					} else if (text.equals(":S")) {
						textField.set(key, ":-\\");
					} else if (text.equals(":o")) {
						textField.set(key, ":O");
					}
				}			

				if (hasCode(key, -3)) {
					settingsKey = key;
					settingsKeyClass = settingsKey.getClass();
				}
				else if( hasCode(key, -2) || hasCode(key, -11)){
					symbIndex = i;
				}
				
				// Insert a pipe in qwerty symbol kb
				if(codes != null && codes.length == 1 && codes[0] == 0x29) {
					key.getClass().getField("codes").set(key, new int[] { 0x29, 0x7C });					
				}

				if (smileyHack && hasCode(key, -4)) {
					
					smileyIndex = i;
					Class c = key.getClass();
					
					String[] smileys = getSmileys();
					
					c.getField("label").set(key, smileys[0]);
					
					StringBuilder sb = new StringBuilder();
					for(String s : smileys) {
						sb.append(s.trim());
						sb.append(" ");
					}
					
					c.getField("popupCharacters").set(key, sb.toString().trim());

					c.getField("codes").set(key, new int[] { -16 });
					c.getField("mFeedBackBG").setInt(key, 1);
					c.getField("accentType").setInt(key, 1);
					c.getField("alignIndex").setInt(key, 0);
					c.getField("textScale").setFloat(key, 0.8f);

					c.getField("icon").set(key, null);
					c.getField("iconPreview").set(key, null);

				}
			}
			
			if(swapSmileys && smileyIndex >= 0 && symbIndex >=0) {
				Object smileyKey = keys.get(smileyIndex);
				Object symbKey = keys.get(symbIndex);
				keys.set(smileyIndex, symbKey);
				keys.set(symbIndex, smileyKey);
				
				swapFields(smileyKey, symbKey, "edgeFlags");
				swapFields(smileyKey, symbKey, "pos");
				swapFields(smileyKey, symbKey, "x");
				swapFields(smileyKey, symbKey, "y");
				swapFields(smileyKey, symbKey, "alignIndex");				
			}

			if (settingsKey == null) {
				// log("no settings key found");
				return;
			}

			int settingsKeyGroup = -1;

			try {
				settingsKeyGroup = settingsKeyClass.getField("mGrouped")
						.getInt(settingsKey);
			} catch (Exception e) {
			}

			int voiceGroupIndex = -1;

			for (int i = 0; i < groups.size(); i++) {
				Class<?> c = groups.get(i).getClass();
				try {
					List groupKeys = (List) c.getField("mKeys").get(
							groups.get(i));
					for (int j = 0; j < groupKeys.size(); j++) {
						if (hasCode(groupKeys.get(j), -23))
							voiceGroupIndex = i;
					}
				} catch (Exception e) {
				}
			}

			if (voiceGroupIndex > -1) {
				// log("voice key already exists");
			} else if (settingsKeyGroup > 0) {
				log("settingsKeyGroup > 0");
			} else {
				try {

					Object voiceKey = settingsKeyClass.newInstance();

					for (Field f : settingsKeyClass.getFields()) {
						try {
							f.set(voiceKey, f.get(settingsKey));
						} catch (Exception ex) {
							// log("voice key skipping field '" + f.getName() +
							// "':" + ex.getMessage());
						}
					}

					Field groupedField = settingsKeyClass.getField("mGrouped");

					groupedField.setInt(settingsKey, 1);
					groupedField.setInt(voiceKey, 1);

					int[] voiceCodes = { -23 };

					settingsKeyClass.getField("codes")
							.set(voiceKey, voiceCodes);

					settingsKeyClass.getField("icon").set(voiceKey,
							service.getResources().getDrawable(0x7F020039));
					settingsKeyClass.getField("iconPreview").set(voiceKey,
							service.getResources().getDrawable(0x7F02006D));
					settingsKeyClass.getField("longpressPreview").set(voiceKey,
							service.getResources().getDrawable(0x7F020072));

					Class<?> groupKeyClass = Class
							.forName("com.htc.android.htcime.ezsip.Keyboard$GroupedKey");

					Object group = groupKeyClass.newInstance();
					groupKeyClass.getField("group").setInt(group, 1);

					List groupedKeys = new ArrayList();

					groupedKeys.add(settingsKey);
					groupedKeys.add(voiceKey);

					groupKeyClass.getField("mKeys").set(group, groupedKeys);

					groups.add(group);

				} catch (Exception e) {
					log("failed to create voice key:" + e.getMessage());
				}
			}
		} catch (Exception e) {
			log("Voice hack error:" + e.toString());
		}
	}

	public static boolean hasCode(Object o, int code) {

		boolean result = false;
		if (o == null)
			return result;

		Class<?> c = o.getClass();
		try {
			Field f = c.getField("codes");
			if (f != null) {
				Object co = f.get(o);
				if (co != null) {
					int[] codes = (int[]) co;
					for (int i = 0; i < codes.length; i++) {
						if (codes[i] == code) {
							result = true;
							break;
						}
					}
				}
			}
		} catch (Exception ex) {
		}

		return result;
	}

	public static int[] getCodes(Object o) {

		try {
			return (int[]) o.getClass().getField("codes").get(o);
		} catch (Exception ex) {
			
			int[] result = {};
			return result;
		}
	}

	
	
	/*
	 * Logging stuff. Used for debugging and research. Calls to these are
	 * inserted into HTC code
	 */

	public static void logOnConfigurationChanged(Configuration c) {
		// log("configuration changed: orientation " + c.orientation );
	}

	public static void log(Object o) {
		String text = o == null ? "null" : o.toString();
		if (text.length() == 0)
			text = "[EMPTY]";
		Log.i(tag, text);
	}

	public static void logStackTrace() {
		StringWriter sw = new StringWriter();
		new Exception().printStackTrace(new PrintWriter(sw));
		log(sw.toString());
	}

	public static void logStackTraceShort() {

		StackTraceElement[] elements = new Exception().getStackTrace();
		StringBuilder sb = new StringBuilder();
		sb.append("StackTrace:\n");
		for (int i = 1; i < elements.length; i++) {

			if (i > 5)
				break;

			sb.append(elements[i].getClassName());
			sb.append(".");
			sb.append(elements[i].getMethodName());
			sb.append("(");
			sb.append(elements[i].getFileName());
			sb.append(":");
			sb.append(elements[i].getLineNumber());
			sb.append(")\n");
		}
		log(sb.toString());
	}

	public static void logServiceKeyUp(int code, KeyEvent e) {
		// log("ServiceKeyUp:" + e.toString() + " code:" + code);
	}

	public static void logBackground(Object o) {
		// log("Background:" + o.toString());
	}

	public static void logDrawBuffer(int w, int h) {
		// log("Draw buffer:" + w + " " + h);
	}

	public static void log(int i) {
		log(String.valueOf(i));
	}

	public static void log(int i, int j) {
		log(String.valueOf(i) + " " + String.valueOf(j));
	}
	
	public static void log(int i, int j, int k) {
		log(String.valueOf(i) + " " + String.valueOf(j) + " " + String.valueOf(k));
	}

	public static void log(int i, int j, int k, int l) {
		log(String.valueOf(i) + " " + String.valueOf(j) + " "
				+ String.valueOf(k) + " " + String.valueOf(l));
	}

	public static void logh(int i) {
		log("0x" + Integer.toHexString(i));
	}
	
	public static void logh(int i, int j) {
		log("0x" + Integer.toHexString(i) + " " + "0x" + Integer.toHexString(j));
	}
	
	public static void logPost(int i) {
		log("pos " + i);
	}
	
	public static void logClear(int i) {
		log("clr " + i);
	}

	public static void log(String[] ss) {
		log(Arrays.toString(ss));
	}

	public static void logPid() {
		log("pid: " + android.os.Process.myPid());
	}

	public static void log(long i) {
		log(String.valueOf(i));
	}

	public static void log(boolean b) {
		log(Boolean.valueOf(b));
	}

	public static void log(float f) {
		log(Float.valueOf(f));
	}

	public static void log(float f1, float f2) {
		log(Float.valueOf(f1) + " " + Float.valueOf(f2));
	}

	public static void log(float[] fs) {
		log(fs == null ? "null" : Arrays.toString(fs));
	}

	public static void log(long[] ls) {
		log(ls == null ? "null" : Arrays.toString(ls));
	}

	public static void log(int[] is) {
		log(is == null ? "null" : Arrays.toString(is));
	}

	public static void log1() {
		log("log1");
	}

	public static void log2() {
		log("log2");
	}

	public static void log3() {
		log("log3");
	}

	public static void log4() {
		log("log4");
	}

	public static void log5() {
		log("log5");
	}

	public static void log6() {
		log("log6");
	}

	public static void log7() {
		log("log7");
	}

	public static void log8() {
		log("log8");
	}

	public static void log9() {
		log("log9");
	}

	public static void log10() {
		log("log10");
	}

	public static void log11() {
		log("log11");
	}

	public static void log12() {
		log("log12");
	}

	public static void logPredictionMode(boolean b1, boolean b2) {
		log("setPredictionMode: " + b1 + " " + b2);
	}

	public static void logLayoutCheckException() {
		log("logLayoutCheckException");
	}

	public static void logEditorInfo(EditorInfo i) {

		StringBuilder it = new StringBuilder();

		int ic = i.inputType & InputType.TYPE_MASK_CLASS;
		int variation = i.inputType & InputType.TYPE_MASK_VARIATION;
		int flags = i.inputType & InputType.TYPE_MASK_FLAGS;

		switch (ic) {
		case InputType.TYPE_CLASS_DATETIME:
			it.append("TYPE_CLASS_DATETIME\n");
			switch (variation) {
			case InputType.TYPE_DATETIME_VARIATION_DATE:
				it.append("TYPE_DATETIME_VARIATION_DATE\n");
				break;
			case InputType.TYPE_DATETIME_VARIATION_TIME:
				it.append("TYPE_DATETIME_VARIATION_TIME\n");
				break;
			case InputType.TYPE_DATETIME_VARIATION_NORMAL:
				it.append("TYPE_DATETIME_VARIATION_NORMAL\n");
				break;
			}
			break;

		case InputType.TYPE_CLASS_NUMBER:
			it.append("TYPE_CLASS_NUMBER\n");

			switch (flags) {
			case InputType.TYPE_NUMBER_FLAG_DECIMAL:
				it.append("TYPE_NUMBER_FLAG_DECIMAL\n");
				break;
			case InputType.TYPE_NUMBER_FLAG_SIGNED:
				it.append("TYPE_NUMBER_FLAG_SIGNED\n");
				break;
			}
			break;

		case InputType.TYPE_CLASS_PHONE:
			it.append("TYPE_CLASS_PHONE\n");
			break;

		case InputType.TYPE_CLASS_TEXT:
			it.append("TYPE_CLASS_TEXT\n");

			switch (variation) {
			case InputType.TYPE_TEXT_VARIATION_EMAIL_ADDRESS:
				it.append("TYPE_TEXT_VARIATION_EMAIL_ADDRESS\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_EMAIL_SUBJECT:
				it.append("TYPE_TEXT_VARIATION_EMAIL_SUBJECT\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_FILTER:
				it.append("TYPE_TEXT_VARIATION_FILTER\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_LONG_MESSAGE:
				it.append("TYPE_TEXT_VARIATION_LONG_MESSAGE\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_NORMAL:
				it.append("TYPE_TEXT_VARIATION_NORMAL\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_PASSWORD:
				it.append("TYPE_TEXT_VARIATION_PASSWORD\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_PERSON_NAME:
				it.append("TYPE_TEXT_VARIATION_PERSON_NAME\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_PHONETIC:
				it.append("TYPE_TEXT_VARIATION_PHONETIC\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_POSTAL_ADDRESS:
				it.append("TYPE_TEXT_VARIATION_POSTAL_ADDRESS\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_SHORT_MESSAGE:
				it.append("TYPE_TEXT_VARIATION_SHORT_MESSAGE\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_URI:
				it.append("TYPE_TEXT_VARIATION_URI\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_VISIBLE_PASSWORD:
				it.append("TYPE_TEXT_VARIATION_VISIBLE_PASSWORD\n");
				break;
			case InputType.TYPE_TEXT_VARIATION_WEB_EDIT_TEXT:
				it.append("TYPE_TEXT_VARIATION_WEB_EDIT_TEXT\n");
				break;
			}

			if ((flags & InputType.TYPE_TEXT_FLAG_AUTO_COMPLETE) != 0)
				it.append("TYPE_TEXT_FLAG_AUTO_COMPLETE\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_AUTO_CORRECT) != 0)
				it.append("TYPE_TEXT_FLAG_AUTO_CORRECT\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_CAP_CHARACTERS) != 0)
				it.append("TYPE_TEXT_FLAG_CAP_CHARACTERS\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_CAP_SENTENCES) != 0)
				it.append("TYPE_TEXT_FLAG_CAP_SENTENCES\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_CAP_WORDS) != 0)
				it.append("TYPE_TEXT_FLAG_CAP_WORDS\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_IME_MULTI_LINE) != 0)
				it.append("TYPE_TEXT_FLAG_IME_MULTI_LINE\n");
			if ((flags & InputType.TYPE_TEXT_FLAG_MULTI_LINE) != 0)
				it.append("TYPE_TEXT_FLAG_MULTI_LINE\n");
			if ((flags & 0x00080000) != 0)
				it.append("TYPE_TEXT_FLAG_NO_SUGGESTIONS\n");
			/*
			 * 
			 * 
			 * switch(flags) { case InputType.TYPE_TEXT_FLAG_AUTO_COMPLETE:
			 * it.append("TYPE_TEXT_FLAG_AUTO_COMPLETE\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_AUTO_CORRECT:
			 * it.append("TYPE_TEXT_FLAG_AUTO_CORRECT\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_CAP_CHARACTERS:
			 * it.append("TYPE_TEXT_FLAG_CAP_CHARACTERS\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_CAP_SENTENCES:
			 * it.append("TYPE_TEXT_FLAG_CAP_SENTENCES\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_CAP_WORDS:
			 * it.append("TYPE_TEXT_FLAG_CAP_WORDS\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_IME_MULTI_LINE:
			 * it.append("TYPE_TEXT_FLAG_IME_MULTI_LINE\n"); break; case
			 * InputType.TYPE_TEXT_FLAG_MULTI_LINE:
			 * it.append("TYPE_TEXT_FLAG_MULTI_LINE\n"); break; case 0x00080000:
			 * it.append("TYPE_TEXT_FLAG_NO_SUGGESTIONS\n"); break; }
			 */

			break;
		}

		StringBuilder imeOptions = new StringBuilder();

		int action = i.imeOptions & EditorInfo.IME_MASK_ACTION;

		switch (action) {
		case EditorInfo.IME_ACTION_DONE:
			imeOptions.append("IME_ACTION_DONE\n");
			break;
		case EditorInfo.IME_ACTION_GO:
			imeOptions.append("IME_ACTION_GO\n");
			break;
		case EditorInfo.IME_ACTION_NEXT:
			imeOptions.append("IME_ACTION_NEXT\n");
			break;
		case EditorInfo.IME_ACTION_SEARCH:
			imeOptions.append("IME_ACTION_SEARCH\n");
			break;
		case EditorInfo.IME_ACTION_SEND:
			imeOptions.append("IME_ACTION_SEND\n");
			break;
		case EditorInfo.IME_ACTION_UNSPECIFIED:
			imeOptions.append("IME_ACTION_UNSPECIFIED\n");
			break;
		}

		if ((i.imeOptions & EditorInfo.IME_FLAG_NO_ACCESSORY_ACTION) != 0)
			imeOptions.append("IME_FLAG_NO_ACCESSORY_ACTION\n");

		if ((i.imeOptions & EditorInfo.IME_FLAG_NO_ENTER_ACTION) != 0)
			imeOptions.append("IME_FLAG_NO_ENTER_ACTION\n");

		if ((i.imeOptions & EditorInfo.IME_FLAG_NO_EXTRACT_UI) != 0)
			imeOptions.append("IME_FLAG_NO_EXTRACT_UI\n");

		StringBuilder initialCapsMode = new StringBuilder();

		if ((i.initialCapsMode & TextUtils.CAP_MODE_CHARACTERS) != 0)
			initialCapsMode.append("CAP_MODE_CHARACTERS\n");

		if ((i.initialCapsMode & TextUtils.CAP_MODE_WORDS) != 0)
			initialCapsMode.append("CAP_MODE_WORDS\n");

		if ((i.initialCapsMode & TextUtils.CAP_MODE_SENTENCES) != 0)
			initialCapsMode.append("CAP_MODE_SENTENCES\n");

		log("--EditorInfo--");
		log("inputType:");
		log(it.toString());

		log("imeOptions:");
		log(imeOptions.toString());

		log("initialCapsMode:");
		log(initialCapsMode.toString());

		log("packageName:" + (i.packageName == null ? "null" : i.packageName)
				+ " actionId:0x" + java.lang.Integer.toHexString(i.actionId)
				+ " actionLabel:" + (i.actionLabel == null ? "null" : i.actionLabel)
				+ " fieldId:0x" + java.lang.Integer.toHexString(i.fieldId)
				+ " hintText:" + (i.hintText == null ? "null" : i.hintText)
				+ " label:" + (i.label == null ? "null" : i.label));
	}

	/* Faking hard keyboard for testing purposes */

	/* Fakes hard keyboard events */
	public static Handler fakeHWHandler = new Handler() {

		public void handleMessage(Message msg) {

			if (fakeHWIndex > fakeHWKeys.size() - 1)
				return;

			KeyEvent e = fakeHWKeys.get(fakeHWIndex);
			if (e.getAction() == KeyEvent.ACTION_DOWN)
				service.onKeyDown(e.getKeyCode(), e);
			else
				service.onKeyUp(e.getKeyCode(), e);

			fakeHWIndex++;

			fakeHWHandler.sendMessageDelayed(Message.obtain(fakeHWHandler, 0),
					500);
		}
	};

	/* Sends the key events */
	public static void initFakeHW() {
		if (fakeHW) {

			fakeHWHandler.removeMessages(0);
			fakeHWIndex = 0;
			fakeHWHandler.sendMessageDelayed(Message.obtain(fakeHWHandler, 0),
					2000);

			fakeHWKeys.clear();

			KeyEvent e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_Z);
			fakeHWKeys.add(e);
			e = KeyEvent.changeAction(e, KeyEvent.ACTION_UP);
			fakeHWKeys.add(e);

			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_SPACE);
			fakeHWKeys.add(e);
			e = KeyEvent.changeAction(e, KeyEvent.ACTION_UP);
			fakeHWKeys.add(e);

			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_S);
			fakeHWKeys.add(e);
			e = KeyEvent.changeAction(e, KeyEvent.ACTION_UP);
			fakeHWKeys.add(e);
			
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_I);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_M);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_U);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_L);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_A);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			 e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_T);
			 fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 
			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_I);
			fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			
			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_N);
			fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			
			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_G);
			fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			
			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_SLASH);
			fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			
			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_SLASH);
			fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			

			e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_ENTER);
			fakeHWKeys.add(e);
			e = KeyEvent.changeAction(e, KeyEvent.ACTION_UP);
			fakeHWKeys.add(e);
			/*
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN,
			 * KeyEvent.KEYCODE_SHIFT_RIGHT); fakeHWKeys.add(e); e =
			 * KeyEvent.changeAction(e, KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_H);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_A);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_R);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_D);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_SPACE);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN,
			 * KeyEvent.KEYCODE_SHIFT_LEFT); fakeHWKeys.add(e); e =
			 * KeyEvent.changeAction(e, KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_K);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_E);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_Y);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_S);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_COMMA);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_DEL);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_PERIOD);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 * 
			 * 
			 * e = new KeyEvent(KeyEvent.ACTION_DOWN, KeyEvent.KEYCODE_ENTER);
			 * fakeHWKeys.add(e); e = KeyEvent.changeAction(e,
			 * KeyEvent.ACTION_UP); fakeHWKeys.add(e);
			 */
		}
	}
}