package jonasl.ime;

import android.view.MotionEvent;

public class SwipeTracker {
	
	private float currX;
	private float currY;
	
	float distX;
	float distY;
	
	float dropLimit = 65f;
	float startLimit = 32f;
	
	private boolean swipeStarted;
	private boolean swipeStartedReported;
	
	public void clear(float startX, float startY) {
		
		currX = startX;
		currY = startY;
		
		distX = 0;
		distY = 0;
		
		swipeStarted = false;
		swipeStartedReported = false;
		//Static.log("clear: " + x + "," + y);
	}
	
	public void setDensity(float d) {
		dropLimit = 64f * d;
		startLimit = 32f * d;
		//Static.log("droplimit " + dropLimit);
	}

	public boolean addMovement(MotionEvent ev) {
		boolean res = false;
		
		long time = ev.getEventTime();
		final int N = ev.getHistorySize();
		for (int i = 0; i < N; i++) {
			res |= addPoint(ev.getHistoricalX(i), ev.getHistoricalY(i), ev
					.getHistoricalEventTime(i));
		}		
		res |= addPoint(ev.getX(), ev.getY(), time);
		
		return res;
	}
	
	public boolean swipeStarted() {
		if(swipeStarted && !swipeStartedReported) {
			swipeStartedReported = true;
			return true;
		}
		
		if(!swipeStarted) {		
			swipeStarted = Math.abs(distX) > startLimit || Math.abs(distY) > startLimit;
		
			//Static.log("swipeStarted " + swipeStarted + " " + Math.abs(distX) + "," + Math.abs(distY));
		
			if(swipeStarted) {
				swipeStartedReported = true;
				return true;
			}
		}
		
		return false;
	}

	private boolean addPoint(float x, float y, long time) {		
		
		boolean res = false;
		float dx = x - currX;
		float dy = y - currY;
		
		//Static.log("addpoint " + dx + "," + dy);
		
		if(Math.abs(dx) > dropLimit || Math.abs(dy) > dropLimit) {
			
			//Static.log("drop: " + dx + "," + dy + "  " + distX + "," + distY);
			res = true;
		}
		else {
			distX += dx;
			distY += dy;	
		}
		
		currX = x;
		currY = y;
		
		//Static.log("move: " + dx + "," + dy + "  " + mDistX + "," + mDistY);
		
		return res;
		
	}
	
}
